unit fROR_ReportParams;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uROR_Selector, uROR_CustomControls, ExtCtrls, StdCtrls,
  ComCtrls, Buttons, uROR_ParamsPanel, fROR_VistARegistries, uROR_Reports,
  uROR_Utilities, Mask, o32flxed, o32editf, ovcbase, ovcef, ovcpb, ovcnf,
  ovcsf, o32rxvld, sablotengine, domimpl, ovcfiler,
  uROR_SelectorTree, ovcstate, uROR_State, uROR_CustomListView,
  uROR_GridView, uROR_ListView, uROR_AdvColGrid, ActnList, uROR_SearchEdit, uROR_DrugSelector,
  uROR_CustomSelector, VirtualTrees, uROR_SelectorGrid, ExeInfo, AdvPanel,
  AdvGrid, Grids, BaseGrid, AdvCGrid, uROR_ICD9Selector, o32vldtr;

type
  TGetFieldMode = (
    gfmDefault, { Load the lists only if they have been changed;
                  do not validate parameters. }

    gfmSave,    { Load all lists; do not validate parameters. }

    gfmRun      { Load all list; validate parameters and display
                  the error messages. }
  );

  TFrameReportParameters = class(TFrame)
    scbxMain: TScrollBox;
    pnlParams010: TCCRParamsPanel;
    spbMin: TSpeedButton;
    spbMax: TSpeedButton;
    rbYear: TRadioButton;
    rbQuarter: TRadioButton;
    rbCustom: TRadioButton;
    cbQuarter: TComboBox;
    dtpFrom: TDateTimePicker;
    dtpTo: TDateTimePicker;
    cbFiscal: TCheckBox;
    rbCutOff: TRadioButton;
    edCutOff: TO32FlexEdit;
    edYear: TO32FlexEdit;
    pnlParams014: TCCRParamsPanel;
    Label8: TLabel;
    Label11: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    dtpScheduleDay: TDateTimePicker;
    dtpScheduleTime: TDateTimePicker;
    cmbbSchedule: TComboBox;
    edTaskComment: TEdit;
    pnlParams026: TCCRParamsPanel;
    cbInpatient: TCheckBox;
    cbOutpatient: TCheckBox;
    pnlParams022: TCCRParamsPanel;
    cbBefore: TCheckBox;
    cbDuring: TCheckBox;
    cbAfter: TCheckBox;
    pnlParams032: TCCRParamsPanel;
    cbCSSN: TCheckBox;
    cbLAST4: TCheckBox;
    cbSelRules: TCheckBox;
    cbDateSelected: TCheckBox;
    pnlParams028: TCCRParamsPanel;
    Bevel23: TBevel;
    cbVERAComplex: TCheckBox;
    cbVERABasic: TCheckBox;
    cbVERAPtList: TCheckBox;
    cbRegMedSMRY: TCheckBox;
    pnlParams060: TCCRParamsPanel;
    cbSeen: TCheckBox;
    cbNotSeen: TCheckBox;
    pnlParams020: TCCRParamsPanel;
    cbConfirmed: TCheckBox;
    cbPending: TCheckBox;
    pnlParams064: TCCRParamsPanel;
    pnlBottomSpacer: TCCRParamsPanel;
    pnlParams030: TCCRParamsPanel;
    cbRace: TCheckBox;
    cbRisk: TCheckBox;
    cbAge: TCheckBox;
    cbSex: TCheckBox;
    cbDateConf: TCheckBox;
    cbUtilization: TCheckBox;
    cbDateOfDeath: TCheckBox;
    pnlParams052: TCCRParamsPanel;
    rbLabTestsAll: TRadioButton;
    rbLabTestsSelected: TRadioButton;
    pnlLabTestSelector: TPanel;
    Bevel8: TBevel;
    ccrLabTestSelector: TCCRSelector;
    pnlParams058: TCCRParamsPanel;
    rbICD9All: TRadioButton;
    rbICD9Selected: TRadioButton;
    pnlICD9ListSelector: TPanel;
    Bevel7: TBevel;
    ccrICD9Selector: TCCRSelector;
    pnlParams050: TCCRParamsPanel;
    rbClinicsAll: TRadioButton;
    rbClinicsSelected: TRadioButton;
    pnlClinicListSelector: TPanel;
    Bevel6: TBevel;
    ccrClinicSelector: TCCRSelector;
    pnlParams034: TCCRParamsPanel;
    rbDivisionsAll: TRadioButton;
    rbDivisionsSelected: TRadioButton;
    pnlDivisionListSelector: TPanel;
    Bevel5: TBevel;
    ccrDivisionSelector: TCCRSelector;
    pnlParams110: TCCRParamsPanel;
    pnlParams046: TCCRParamsPanel;
    Label24: TLabel;
    edHighestUtilNum046: TO32FlexEdit;
    rbSummaryUsers: TRadioButton;
    rbDetailsUsers: TRadioButton;
    pnlParams120: TCCRParamsPanel;
    Label14: TLabel;
    Label46: TLabel;
    edMinRPNum120: TO32FlexEdit;
    edHighestUtilNum120: TO32FlexEdit;
    rbSummaryBoth: TRadioButton;
    rbDetailsBoth: TRadioButton;
    pnlParams056: TCCRParamsPanel;
    cbInvestigDrugs056: TCheckBox;
    pnlParams044: TCCRParamsPanel;
    Label38: TLabel;
    rbGenericDrugs044: TRadioButton;
    rbDispensedDrugs044: TRadioButton;
    pnlParams042: TCCRParamsPanel;
    cbInvestigDrugs042: TCheckBox;
    cbRegistryDrugs042: TCheckBox;
    pnlParams140: TCCRParamsPanel;
    pnlPatientListSelector: TPanel;
    Bevel4: TBevel;
    ccrPatientSelector: TCCRSelector;
    pnlParams084: TCCRParamsPanel;
    pnlTopSpacer: TCCRParamsPanel;
    pnlParams054: TCCRParamsPanel;
    pnlDrugTreeSelector: TPanel;
    pnlDrugSearch054: TPanel;
    Bevel1: TBevel;
    cseDrugSearch: TCCRVistASearchEdit;
    vxsComponentState: TCCRComponentState;
    pnlDrugGroup: TPanel;
    edDrugGroupName: TEdit;
    spbDrugGroupAdd: TSpeedButton;
    cmbxDrugSearch054: TComboBox;
    pnlPatientSearch140: TPanel;
    csePatientSearch: TCCRVistASearchEdit;
    pnlDivisionSearch: TPanel;
    cseDivisionSearch: TCCRVistASearchEdit;
    pnlClinicSearch: TPanel;
    cseClinicSearch: TCCRVistASearchEdit;
    pnlICD9Search: TPanel;
    cseICD9Search: TCCRVistASearchEdit;
    pnlLabTestSearch: TPanel;
    cseLabTestSearch: TCCRVistASearchEdit;
    cmbbICD9Search: TComboBox;
    pnlParams059: TCCRParamsPanel;
    rbCPTAll: TRadioButton;
    rbCPTSelected: TRadioButton;
    Panel1: TPanel;
    Bevel9: TBevel;
    ccrCPTSelector: TCCRSelector;
    Panel2: TPanel;
    cseCPTSearch: TCCRVistASearchEdit;
    cmbbCPTSearch: TComboBox;
    pnlParams070: TCCRParamsPanel;
    Label4: TLabel;
    pnlParams100: TCCRParamsPanel;
    pnlParams130: TCCRParamsPanel;
    cgvSelectionRules: TCCRGridView;
    Label3: TLabel;
    cbDateSel: TCheckBox;
    cbSSN: TCheckBox;
    pnlParams035: TCCRParamsPanel;
    rbUTAll: TRadioButton;
    rbUTSelected: TRadioButton;
    cbUTAllergy: TCheckBox;
    cbUTCytopathology: TCheckBox;
    cbUTInpatient: TCheckBox;
    cbUTPharmacyIP: TCheckBox;
    cbUTPharmacyIV: TCheckBox;
    cbUTLaboratory: TCheckBox;
    cbUTMicrobiology: TCheckBox;
    cbUTOutpatient: TCheckBox;
    cbUTPharmacyOP: TCheckBox;
    cbUTRadiology: TCheckBox;
    cbUTSurgPath: TCheckBox;
    cbDateConfirmed: TCheckBox;
    cbDOD: TCheckBox;
    pnlParams047: TCCRParamsPanel;
    Label5: TLabel;
    pnlParams062: TCCRParamsPanel;
    rbComplete: TRadioButton;
    rbSummary: TRadioButton;
    cbDateOfBirth: TCheckBox;
    aclParams: TActionList;
    acCancelSearch: TAction;
    ccrDrugSelector: TCCRDrugSelector;
    rbDrugsSelected: TRadioButton;
    spbDrugGroupDelete: TSpeedButton;
    acDrugGroupDelete: TAction;
    acDrugGroupAdd: TAction;
    pnlParams011: TCCRParamsPanel;
    spbMin011: TSpeedButton;
    spbMax011: TSpeedButton;
    rbYear011: TRadioButton;
    rbQuarter011: TRadioButton;
    rbCustom011: TRadioButton;
    cbQuarter011: TComboBox;
    dtpFrom011: TDateTimePicker;
    dtpTo011: TDateTimePicker;
    cbFiscal011: TCheckBox;
    rbCutOff011: TRadioButton;
    edCutOff011: TO32FlexEdit;
    edYear011: TO32FlexEdit;
    cbgPharmacy: TCCRCBGroup;
    cbgLab: TCCRCBGroup;
    pnlParams066: TCCRParamsPanel;
    cbCareOnly: TCheckBox;
    pnlParams053: TCCRParamsPanel;
    rbLTRAll: TRadioButton;
    rbLTRSelected: TRadioButton;
    Panel3: TPanel;
    Bevel2: TBevel;
    pnlLTRSearch: TPanel;
    cseLTRSearch: TCCRVistASearchEdit;
    ccrLTRSelector: TCCRSelectorGrid;
    pnlParams012: TCCRParamsPanel;
    spbMin012: TSpeedButton;
    spbMax012: TSpeedButton;
    rbYear012: TRadioButton;
    rbQuarter012: TRadioButton;
    rbCustom012: TRadioButton;
    cbQuarter012: TComboBox;
    dtpFrom012: TDateTimePicker;
    dtpTo012: TDateTimePicker;
    cbFiscal012: TCheckBox;
    rbCutOff012: TRadioButton;
    edCutOff012: TO32FlexEdit;
    edYear012: TO32FlexEdit;
    pnlLabRanges: TPanel;
    agLabRanges: TCCRAdvColGrid;
    AdvPanel1: TAdvPanel;
    agLocalFields: TCCRAdvColGrid;
    agRegistries: TCCRAdvColGrid;
    pnlParams065: TCCRParamsPanel;
    rbRcvdProcedures: TRadioButton;
    rbDidNotRcvdProcedures: TRadioButton;
    rbPatientsSelected: TRadioButton;
    rbPatientsAll: TRadioButton;
    pnlParams150: TCCRParamsPanel;
    cbInpatient150: TCheckBox;
    cbOutpatient150: TCheckBox;
    pnlParams160: TCCRParamsPanel;
    pnlICD9Selector: TPanel;
    Bevel3: TBevel;
    pnlICD9Search160: TPanel;
    cseICD9Search160: TCCRVistASearchEdit;
    pnlICD9Group160: TPanel;
    spbICD9GroupAdd: TSpeedButton;
    spbICD9GroupDelete: TSpeedButton;
    edICD9GroupName: TEdit;
    cmbxICD9Search160: TComboBox;
    ccrICD9Selector160: TCCRICD9Selector;
    rbAll160: TRadioButton;
    rbSelected160: TRadioButton;
    acICD9GroupDelete: TAction;
    acICD9GroupAdd: TAction;
    RegexValidator: TO32RegExValidator;
    rbLTRMostRecentAll: TRadioButton;
    rbLTRMostRecent: TRadioButton;
    pnlParams180: TCCRParamsPanel;
    pnlOtherDiagTemplateSelector: TPanel;
    Bevel10: TBevel;
    pnlOtherDiagSearch180: TPanel;
    cmbxOtherDiagSearch180: TComboBox;
    ccrOtherDiagSelector180: TCCRICD9Selector;
    rbIgnore180: TRadioButton;
    rbInclude180: TRadioButton;
    rbExclude180: TRadioButton;
    rbDrugsAll: TRadioButton;
    cbPendingComments: TCheckBox;
    btnAllRegistryMeds: TButton;
    acOtherDiagGroupDelete: TAction;
    pnlParams201: TCCRParamsPanel;
    rbRangeMostRecent: TRadioButton;
    rbRangeMax: TRadioButton;
    dtpRangeMaxDate: TDateTimePicker;
    Label6: TLabel;
    lblSearch140: TLabel;
    lblSearch050: TLabel;
    lblSearch052: TLabel;
    lblSearch053: TLabel;
    lblSearch034: TLabel;
    lblSearchBy059: TLabel;
    lblSearch059: TLabel;
    pnlLabels054: TPanel;
    lblSearchBy054: TLabel;
    lblSearch054: TLabel;
    lblGroupName054: TLabel;
    pnlLabels160: TPanel;
    lblSearchBy160: TLabel;
    lblSearch160: TLabel;
    lblGroupName160: TLabel;
    procedure pnlParams010SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure rbDateRangeClick(Sender: TObject);
    procedure pnlParams010GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure spbMinClick(Sender: TObject);
    procedure spbMaxClick(Sender: TObject);
    procedure pnlParams022SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams022GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams020GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams020SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams026GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams026SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams032GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams032SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams028GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams028SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams060GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams060SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams064GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams064SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams030GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams030SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams042GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams042SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams044GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams044SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams056GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams056SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams120GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams120SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure rbSummaryBothClick(Sender: TObject);
    procedure rbDetailsBothClick(Sender: TObject);
    procedure pnlParams046GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams046SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure rbSummaryUsersClick(Sender: TObject);
    procedure rbDetailsUsersClick(Sender: TObject);
    procedure pnlParams014GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams014SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams052GetValues(const aReportCode: String; aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams052SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure cseLabTestSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure pnlParams058GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams058SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure cseSearch(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure cseSearchEnd(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure pnlParams059GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams059SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure cseCPTSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure ccrCPTSelectorSplitterMoved(Sender: TObject);

    procedure pnlParams050GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams050SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure cseClinicSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure cseDivisionSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure pnlParams034GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams034SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure rbAllClick(Sender: TObject);
    procedure rbSelectedClick(Sender: TObject);
    procedure pnlParams140GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams140SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure csePatientSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure ccrDrugSelectorSplitterMoved(Sender: TObject);
    procedure pnlDrugGroupResize(Sender: TObject);
    procedure pnlParams054SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams054GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure cseDrugSearchSearchStart(aSender: TObject; var aCommand: TCCRSearchCommand);
    procedure ccrPatientSelectorSplitterMoved(Sender: TObject);
    procedure ccrDivisionSelectorSplitterMoved(Sender: TObject);
    procedure ccrClinicSelectorSplitterMoved(Sender: TObject);
    procedure ccrICD9SelectorSplitterMoved(Sender: TObject);
    procedure ccrLabTestSelectorSplitterMoved(Sender: TObject);
    procedure pnlParams070SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams070GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams100GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams100SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams130GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams130SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams047Setup(const aReportCode: string);
    procedure pnlParams047GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams047SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams062GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams062SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure pnlParams035GetValues(const aReportCode: String; aList: TCustomReportParameters;
      aMsgLst: TStrings; var aField: TWinControl);
    procedure pnlParams035SetValues(const aReportCode: String; aList: TCustomReportParameters);
    procedure agLabRangesCheckBoxClick(Sender: TObject; ACol,
      ARow: Integer; State: Boolean);
    procedure agRangesSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure acCancelSearchExecute(Sender: TObject);
    procedure cseICD9SearchSearchStart(aSender: TObject;
      var aCommand: TCCRSearchCommand);
    procedure cmbxDrugSearch054Select(Sender: TObject);
    procedure acDrugGroupDeleteExecute(Sender: TObject);
    procedure acDrugGroupAddExecute(Sender: TObject);
    procedure ccrDrugSelectorResultListKeyAction(
      Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
      var DoDefault: Boolean);
    procedure edDrugGroupNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pnlParams054Setup(const aReportCode: String);
    procedure pnlParams010Setup(const aReportCode: String);
    procedure pnlParams011GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams011SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure rbDateRange011Click(Sender: TObject);
    procedure spbMin011Click(Sender: TObject);
    procedure spbMax011Click(Sender: TObject);
    procedure pnlParams052Setup(const aReportCode: String);
    procedure cbgPharmacyChange(Sender: TObject);
    procedure cbgLabChange(Sender: TObject);
    procedure pnlParams066GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams066SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure cseLTRSearchSearchStart(aSender: TObject;
      var aCommand: TCCRSearchCommand);
    procedure pnlParams053GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams053Setup(const aReportCode: String);
    procedure pnlParams053SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure ccrLTRSelectorSplitterMoved(Sender: TObject);
    procedure ccrLTRSelectorResultListGetDisplText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure ccrLTRSelectorResultListCanEditCell(Sender: TObject; ARow,
      ACol: Integer; var CanEdit: Boolean);
    procedure ccrLTRSelectorResultListCustomCompare(Sender: TObject; str1,
      str2: String; var Res: Integer);
    procedure rbDateRange012Click(Sender: TObject);
    procedure spbMin012Click(Sender: TObject);
    procedure spbMax012Click(Sender: TObject);
    procedure pnlParams012GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams012SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure cbCareOnlyClick(Sender: TObject);
    procedure pnlParams011ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams012ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams010ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams052ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams053ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams054ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams044ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure vxsComponentStateRestoreState(Sender: TObject);
    procedure vxsComponentStateSaveState(Sender: TObject);
    procedure agRegistriesCellChanging(Sender: TObject; OldRow, OldCol,
      NewRow, NewCol: Integer; var Allow: Boolean);
    procedure agLocalFieldsCellChanging(Sender: TObject; OldRow, OldCol,
      NewRow, NewCol: Integer; var Allow: Boolean);
    procedure pnlParams065GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams065SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure rbPatientsAllClick(Sender: TObject);
    procedure rbPatientsSelectedClick(Sender: TObject);
    procedure pnlParams150GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams150SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure cbInpatient150Click(Sender: TObject);
    procedure cbOutpatient150Click(Sender: TObject);
    procedure pnlParams160ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams160GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams160SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure cseICD9Search160SearchStart(aSender: TObject;
      var aCommand: TCCRSearchCommand);
    procedure pnlICD9Group160Resize(Sender: TObject);
    procedure edICD9GroupNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pnlParams160Setup(const aReportCode: String);
    procedure ccrICD9Selector160SplitterMoved(Sender: TObject);
    procedure acICD9GroupDeleteExecute(Sender: TObject);
    procedure acICD9GroupAddExecute(Sender: TObject);
    procedure ccrICD9Selector160ResultListKeyAction(
      Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
      var DoDefault: Boolean);
    procedure pnlParams053ConstrainedResize(Sender: TObject; var MinWidth,
      MinHeight, MaxWidth, MaxHeight: Integer);
    procedure rbLTRAllClick(Sender: TObject);
    procedure pnlParams180ClearParams(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure pnlParams180GetValues(const aReportCode: String;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams180Setup(const aReportCode: String);
    procedure pnlParams180SetValues(const aReportCode: String;
      aList: TCustomReportParameters);
    procedure cmbxOtherDiagSearch180Select(Sender: TObject);
    procedure rbIgnore180Click(Sender: TObject);
    procedure ccrOtherDiagSelector180Add(Sender: TObject);
    procedure ccrDrugSelectorAdd(Sender: TObject);
    procedure ccrDrugSelectorAddAll(Sender: TObject);
    procedure ccrOtherDiagSelector180AddAll(Sender: TObject);
    procedure cbPendingClick(Sender: TObject);
    procedure btnAllRegistryMedsClick(Sender: TObject);
    procedure rbDrugsSelectedClick(Sender: TObject);
    procedure rbDrugsAllClick(Sender: TObject);
    procedure ccrOtherDiagSelector180RemoveAll(Sender: TObject);
    procedure ccrOtherDiagSelector180Remove(Sender: TObject);
    procedure ccrOtherDiagSelector180ResultListKeyAction(
      Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
      var DoDefault: Boolean);
    procedure acOtherDiagGroupDeleteExecute(Sender: TObject);
    procedure pnlParams201GetValues(const aReportCode: string;
      aList: TCustomReportParameters; aMsgLst: TStrings;
      var aField: TWinControl);
    procedure pnlParams201SetValues(const aReportCode: string;
      aList: TCustomReportParameters);
    procedure pnlParams201Setup(const aReportCode: string);
    procedure rbToggleDateEntry(Sender: TObject);

  private
    { If fFullUpdate is True, the GetFieldValues retrieves values from all
      controls. Otherwise, some unchanged lists will not be retrieved. }
    fFullUpdate: Boolean;

    { References to the nodes that are checked/updated most often }
    fNodeDrugs:    TDomNode;
    fNodeColumns:  TDomNode;
    fNodeOptions:  TDomNode;
    fNodePatients: TDomNode;

    { fRegInfo stores a reference to the registry descriptor }
    fRegInfo: TRegistryInfo;

    { References to lists of lab tests }
    fRegTests:    TStringList;
    fBMITests:    TStringList;
    fMELDTests:   TStringList;
    fRenalTests:  TStringList;

    function  getColumnOption(const aName: String): Boolean;
    procedure setColumnOption(const aName: String; aValue: Boolean);
    procedure setRegInfo(aRegInfo: TRegistryInfo);
    function  getICD9Filter: String;
    function  getICD9FilterType: String;
    procedure loadOtherDiagList;

  protected
    procedure CreateWnd; override;
    function isCutOffValid(const aText: String): Boolean;
    function  validateScheduleCode(const aCode: String;
      const aDateTime: TDateTime): Boolean;

    property FullUpdate: Boolean        read  fFullUpdate;

    property NodeDrugs: TDomNode        read  fNodeDrugs;
    property NodeColumns: TDomNode      read  fNodeColumns;
    property NodeOptions: TDomNode      read  fNodeOptions;
    property NodePatients: TDomNode     read  fNodePatients;
    property ICD9Filter: String         read  getICD9Filter;
    property ICD9FilterType: String     read  getICD9FilterType;

  public
    constructor Create(anOwner: TComponent); override;

    function  GetDTRun: TDateTime;
    function  GetFieldValues(const aReportCode: String;
      ReportParams: TReportParameters; aMode: TGetFieldMode = gfmDefault): TWinControl;
    procedure SetFieldValues(const aReportCode: String;
      ReportParams: TReportParameters);
    procedure SetupPanels(aReport: TReportDescriptor);
    procedure UpdatePanelReferences;

    property RegInfo: TRegistryInfo     read  fRegInfo
                                        write setRegInfo;

  end;

implementation
{$R *.dfm}

uses
  StrUtils, uROR_Common, uROR_CommonUtils, uROR_Broker, uROR_CustomBroker, DateUtils,
  fROR_ReportSelector, uROR_Strings, sdom, fROR_Options;

const
  dtrsCustom  = 'CUSTOM';
  dtrsCutOff  = 'CUTOFF';
  dtrsEnd     = 'END';
  dtrsFiscal  = 'FISCAL';
  dtrsQuarter = 'QUARTER';
  dtrsStart   = 'START';
  dtrsType    = 'TYPE';
  dtrsYear    = 'YEAR';

  dirNone   = 0;
  dirCommon = 1;
  dirUser   = 2;

  iName  = 0;
  iIEN   = 1;
  iDescr = 2;

  lfMode  = 0;
  lfName  = 1;
  lfDescr = 2;
  lfIEN   = 3;

  lrgToggle    = 0;
  lrgGroupName = 1;
  lrgLow       = 2;
  lrgHigh      = 3;
  lrgGroupCode = 4;

  ltrName  = 0;
  ltrPanel = 1;
  ltrLow   = 2;
  ltrHigh  = 3;
  ltrIEN   = 4;

  orMode  = 0;
  orDescr = 1;
  orName  = 2;
  orIEN   = 3;

  ssClinicSelector   = 'ClinicSelector';
  ssCPTSelector      = 'CPTSelector';
  ssDivisionSelector = 'DivisionSelector';
  ssDrugSelector     = 'DrugSelector';
  ssICD9Selector     = 'ICD9Selector';
  ssLabRanges        = 'LabRanges';
  ssLabTestSelector  = 'LabTestSelector';
  ssLocalFields      = 'LocalFields';
  ssLTRSelector      = 'LTRSelector';
  ssPatientSelector  = 'PatientSelector';
  ssRegistries       = 'Registries';

function checkRange(const aLow, aHigh: String): Boolean;
begin
  Result := (StrToFloatDef(aLow,0) <= StrToFloatDef(aHigh,0)) or
            (aLow = '') or (aHigh = '');
end;

//***** LOADS THE RESULT LIST OF THE SELECTOR

procedure loadSelectorResult(aSelector: TCCRSelector; aList: TDomNode;
  anAttrList: array of String);
var
  i: Integer;
  node, txtNode: TDomNode;
begin
  with aSelector.ResultList.Items do
    begin
      BeginUpdate;
      try
        //--- Clear both lists of the selector
        aSelector.Clear;
        if Assigned(aList) then
          begin
            //--- Load the result list from the report parameters
            node := aList.FirstChild;
            while node <> nil do
              begin
                if node.NodeType = SDOM_ELEMENT_NODE then
                  with Add do
                    begin
                      for i:=0 to High(anAttrList) do
                        if anAttrList[i] = '*' then
                          begin
                            txtNode := node.FindNode('text()');
                            if txtNode <> nil then
                              AsString[i] := txtNode.NodeValue;
                          end
                        else if anAttrList[i] <> '' then
                          AsString[i] := node.getAttribute(anAttrList[i]);
                    end;
                node := node.NextSibling;
              end;
          end;
      finally
        EndUpdate;
      end;
    end;
  aSelector.ResultChanged := False;
end;

procedure loadSelectorGridResult(aSelector: TCCRSelectorGrid; aList: TDomNode;
  anAttrList: array of String);
var
  i, cr: Integer;
  node, txtNode: TDomNode;
begin
  with aSelector.ResultList do
    begin
      BeginUpdate;
      try
        //--- Clear both lists of the selector
        aSelector.Clear;
        if Assigned(aList) then
          begin
            //--- Load the result list from the report parameters
            node := aList.FirstChild;
            while node <> nil do
              begin
                if node.NodeType = SDOM_ELEMENT_NODE then
                  begin
                    AddRow;
                    cr := RealRowIndex(RowCount - 1);
                    for i:=0 to High(anAttrList) do
                      if anAttrList[i] = '*' then
                        begin
                          txtNode := node.FindNode('text()');
                          if txtNode <> nil then
                            AllCells[i,cr] := txtNode.NodeValue;
                        end
                      else if anAttrList[i] <> '' then
                        AllCells[i,cr] := node.getAttribute(anAttrList[i]);
                  end;
                node := node.NextSibling;
              end;
          end;
      finally
        EndUpdate;
      end;
    end;
  aSelector.ResultChanged := False;
end;

procedure deleteResultTreeGroup(aTree: TCCRICD9SelectorTree);
var
  next, node: PVirtualNode;
  rc: Word;
begin
  with aTree do
    begin
      rc := mrNo;
      next := GetFirstChild(RootNode);
      while Assigned(next) do
        begin
          node := next;
          next := GetNextSibling(node);
          if Selected[node] then
            begin
              if rc <> mrYesToAll then
                begin
                  rc := MessageDialog(rscReportParameters,
                          Format(RSC00223,[AsString[node,idscName]]),
                          mtConfirmation, [mbYes,mbNo,mbYesToAll,mbCancel], mrNo, 0);
                  if rc = mrCancel then
                    Break;
                end;
              if (rc = mrYesToAll) or (rc = mrYes) then
                DeleteGroup(node);
            end;
        end;
    end;
end;

//***** LOADS THE RESULT RANGE GRID WITH A LIST OF TESTS

procedure loadResultRangeGrid(aGrid: TCCRAdvColGrid; aList: TStringList; aHeader: string);
begin
  with aGrid do
  begin
    RemoveAll;
    AssignRawData(aList, [-1,2,-1,-1,3]);
    SortSettings.Column := lrgGroupName;
    SortSettings.Direction := AdvGrid.sdAscending;
    QSort;
    ColumnHeaders[1] := aHeader;
  end;
end;

//////////////////////////// TFrameReportParameters \\\\\\\\\\\\\\\\\\\\\\\\\\\\

constructor TFrameReportParameters.Create(anOwner: TComponent);
var
  dtn: TDateTime;
begin
  inherited;
  agLabRanges.HideColumn(lrgGroupCode);
  agLocalFields.HideColumn(lfIEN);;
  dtn := GetServerDateTime();
  dtpScheduleDay.DateTime  := DateOf(dtn);
  dtpScheduleTime.DateTime := TimeOf(dtn);

  with agRegistries do
    begin
      HideColumn(orIEN);;
      HideColumn(orName);;
    end;

  with ccrDrugSelector do
    begin
      cseDrugSearch.SearchGrid := SourceList;
      SourceList.Fields[idscCode].Visible := False;
      SourceType := idstGeneric;
    end;

  with ccrLTRSelector do
    begin
      Clear;
      ResultList.HideColumn(ltrIEN);
      cseLTRSearch.SearchGrid := SourceList;
    end;

  with ccrICD9Selector160 do
    begin
      cseICD9Search160.SearchGrid := SourceList;
    end;
end;

//*****

procedure TFrameReportParameters.acCancelSearchExecute(Sender: TObject);
begin
  cseClinicSearch.CancelSearch;
  cseCPTSearch.CancelSearch;
  cseDivisionSearch.CancelSearch;
  cseICD9Search.CancelSearch;
  cseICD9Search160.CancelSearch;
  cseLabTestSearch.CancelSearch;
  cseLTRSearch.CancelSearch;
  csePatientSearch.CancelSearch;
end;

//*****

procedure TFrameReportParameters.CreateWnd;
begin
  inherited;
  AccAnnotate(Self);
end;

//*****

function TFrameReportParameters.getICD9Filter: String;
begin
  if rbInclude180.Checked then
    Result := 'INCLUDE'
  else if rbExclude180.Checked then
    Result := 'EXCLUDE'
  else
    Result := 'ALL';
end;

//*****

function TFrameReportParameters.getICD9FilterType: String;
begin
  if cmbxOtherDiagSearch180.ItemIndex = dirCommon then
    Result := 'PKG'
  else if cmbxOtherDiagSearch180.ItemIndex = dirUser then
    Result := 'USR';
end;

//*****

procedure TFrameReportParameters.cseSearch(
  aSender: TObject; var aCommand: TCCRSearchCommand);
var
  n: Integer;
  searchFrom: String;
begin
  with TCCRVistASearchEdit(aSender) do
    if Broker.CallProc(SearchRPCName, SearchParams, nil, RawData) then
      begin
        //--- Check number of loaded records
        n := StrToIntDef(Piece(RawData[0],U), 0);
        searchFrom := Piece(RawData[0], U, 2, 99);
        if n > 0 then
          begin
            Inc(SearchCount, n);
            //--- Add the records to the list
            RawData.Delete(0);
            SearchGrid.Items.AppendRawData(RawData, SearchFieldsArray, U, SearchStrPerItem);
            //--- Check if the maximum number of records has been reached
            if (SearchMaxCount > 0) and (SearchCount >= SearchMaxCount) then
              aCommand := cscFinish;
          end;
        //--- Check if there are more records to load
        if SearchFromIndex >= 0 then
          begin
            SearchParams[SearchFromIndex] := searchFrom;
            if searchFrom = '' then
              aCommand := cscFinish;
          end
        else
          aCommand := cscFinish;
      end
    else
      aCommand := cscCancel;
end;

//*****

procedure TFrameReportParameters.cseSearchEnd(aSender: TObject;
  var aCommand: TCCRSearchCommand);
begin
  with TCCRVistASearchEdit(aSender) do
    begin
      //--- Display a warning if not all records have been loaded
      if (SearchMaxCount > 0) and (SearchCount > SearchMaxCount) then
        MessageDlg(rscSearchTooMany, mtInformation, [mbOK], 0);

      //--- Display a warning if no records have been found.
      //    Otherwise, move focus to the list.
      if SearchGrid.Items.Count > 0 then
        begin
          SearchGrid.AlphaSort;
          SearchGrid.SetFocus;
        end
      else
        MessageDlg(rscSearchNone, mtInformation, [mbOK], 0);
    end;
end;

//*****

function TFrameReportParameters.getColumnOption(const aName: String): Boolean;
begin
  if Assigned(NodeColumns) then
    Result := (NodeColumns.FindNode('COLUMN[@ID="'+aName+'"]') <> nil)
  else
    Result := False;
end;

//***** COMBINES DATE AND TIME FROM THE SCHEDULE CONTROLS

function TFrameReportParameters.GetDTRun: TDateTime;
begin
  Result := Trunc(dtpScheduleDay.Date) + dtpScheduleTime.Time -
    Trunc(dtpScheduleTime.Time);
end;

//***** UPDATES THE REPORT PARAMETERS WITH CURRENT VALUES OF VISIBLE CONTROLS

function TFrameReportParameters.GetFieldValues(const aReportCode: String;
  ReportParams: TReportParameters; aMode: TGetFieldMode): TWinControl;
var
  i, iCtrl, lastCtrl, n: Integer;
  ctrl: TWinControl;
  messageList, msgLst: TStringList;
  msg, panelCaption, prevCaption: String;
begin
  Result := nil;
  panelCaption := '';
  prevCaption  := '';
  fFullUpdate := (aMode <> gfmDefault);
  messageList := TStringList.Create;
  msgLst := TStringList.Create;

  try
    with scbxMain do
      begin
        //--- Find common nodes (create if necessary)
        with ReportParams do
          begin
            fNodeDrugs    := GetNode('/PARAMS/DRUGS');
            fNodeColumns  := GetNode('/PARAMS/OPTIONAL_COLUMNS');
            fNodeOptions  := GetNode('/PARAMS/OPTIONS');
            fNodePatients := GetNode('/PARAMS/PATIENTS');
          end;

        //--- Get the parameter values and validate them
        lastCtrl := ControlCount - 1;
        for iCtrl:=0 to lastCtrl do
          if (Controls[iCtrl] is TCCRParamsPanel) and Controls[iCtrl].Visible then
            begin
              with TCCRParamsPanel(Controls[iCtrl]) do
                if Caption <> '' then
                  panelCaption := Caption;
              msgLst.Clear;

              //--- Get parameter values from the panel
              ctrl := TCCRParamsPanel(Controls[iCtrl]).GetFieldValues(
                aReportCode, ReportParams, msgLst);

              //--- Collect the error messages if the errors have been
              //    encountered and parameter validation is requested
              if Assigned(ctrl) and (aMode = gfmRun) then
                begin
                  //--- Remember the first erroneous control
                  if not Assigned(Result) then
                    Result := ctrl;
                  //--- Add the panel caption as a heading
                  if (panelCaption <> '') and (panelCaption <> prevCaption) then
                    begin
                      messageList.Add('');
                      messageList.Add(panelCaption);
                      prevCaption := panelCaption;
                    end;
                  //--- Append the panel messages to the message list
                  n := msgLst.Count - 1;
                  for i:=0 to n do
                    messageList.Add(#9 + msgLst[i]);
                end;
            end;
      end;

    if Assigned(Result) then
      begin
        //--- Otherwise, display the error messages
        msg := RSC00200;
        if messageList.Count > 0 then
          msg := msg + ': ' + #13
        else
          msg := msg + '.';
        MessageDlg(msg + messageList.Text, mtError, [mbOK], 0);
      end;

  finally
    //--- Always free the temporary buffers
    msgLst.Free;
    messageList.Free;
  end;
end;

function TFrameReportParameters.isCutOffValid(const aText: String): Boolean;
begin
  with RegexValidator do
    begin
      Mask := '(T(ODAY)?)?(\-)?[0-9]+[DMW]?';
      Input := aText;
      Result := IsValid;
    end;
end;

//***** DISABLE PANEL CONTROLS IF THE 'INCLUDE ALL' RADIO-BUTTON IS SELECTED

procedure TFrameReportParameters.rbAllClick(Sender: TObject);
  procedure rb_all(ctrl: TWinControl);
  var
    i: Integer;
  begin
    with ctrl do
      for i:=ControlCount-1 downto 0 do
        begin
          if Controls[i] is TCCRAdvColGrid then
            Controls[i].Enabled := False
          else if Controls[i] is TCCRCustomSelector then
          begin
            TCCRCustomSelector(Controls[i]).Clear;
            Controls[i].Enabled := False;
            if Controls[i] is TCCRSelectorGrid then
              TCCRSelectorGrid(Controls[i]).ResultList.Color := CtrlColor(False);
          end
          else if Controls[i] is TCCRSearchEdit then
            begin
              TCCRSearchEdit(Controls[i]).Text := '';
              Controls[i].Enabled := False;
            end
          else if Controls[i] is TComboBox then
            begin
              TComboBox(Controls[i]).Color := CtrlColor(False);
              Controls[i].Enabled := False;
            end
          else if Controls[i] is TCheckBox then
            Controls[i].Enabled := False
          else if Controls[i] is TEdit then
            begin
              TEdit(Controls[i]).Color := CtrlColor(False);
              Controls[i].Enabled := False;
            end
          else if Controls[i] is TPanel then
            Controls[i].Enabled := False;
          //--- Recursively search for child controls
          if Controls[i] is TWinControl then
            rb_all(TWinControl(Controls[i]));
        end;
  end;
begin
  with TWinControl(Sender) do
    if Assigned(Parent) then
      rb_all(Parent);
end;

procedure TFrameReportParameters.rbLTRAllClick(Sender: TObject);
begin
  rbAllClick(Sender);
  // Enable the 'most recent' lab test radio buttons
  panel3.Enabled := True;
  pnlLTRSearch.Enabled := True;
  rbLTRMostRecentAll.Enabled := True;
  rbLTRMostRecent.Enabled := True;
end;

//***** ENABLE PANEL CONTROLS IF THE 'SELECTED ONLY' RADIO-BUTTON IS SELECTED

procedure TFrameReportParameters.rbSelectedClick(Sender: TObject);
  procedure rb_selected(ctrl: TWinControl);
  var
    i: Integer;
  begin
    with ctrl do
      for i:=ControlCount-1 downto 0 do
        begin
          if Controls[i] is TCCRAdvColGrid then
            Controls[i].Enabled := True
          else if Controls[i] is TCCRCustomSelector then
          begin
            Controls[i].Enabled := True;
            if Controls[i] is TCCRSelectorGrid then
              TCCRSelectorGrid(Controls[i]).ResultList.Color := CtrlColor(True);
          end
          else if Controls[i] is TCCRSearchEdit then
            Controls[i].Enabled := True
          else if Controls[i] is TComboBox then
            begin
              TComboBox(Controls[i]).Color := CtrlColor(True);
              Controls[i].Enabled := True;
            end
          else if Controls[i] is TCheckBox then
            Controls[i].Enabled := True
          else if Controls[i] is TEdit then
            begin
              TEdit(Controls[i]).Color := CtrlColor(True);
              Controls[i].Enabled := True;
            end
          else if Controls[i] is TPanel then
            Controls[i].Enabled := True;
          //--- Recursively search for child controls
          if Controls[i] is TWinControl then
            rb_selected(TWinControl(Controls[i]));
        end;
  end;
begin
  with TWinControl(Sender) do
    if Assigned(Parent) then
      rb_selected(Parent);
end;

//*****

procedure TFrameReportParameters.setColumnOption(const aName: String; aValue: Boolean);
  var
    node: TDomNode;
begin
  with NodeColumns.OwnerDocument do
    begin
      node := NodeColumns.FindNode('COLUMN[@ID="'+aName+'"]');
      if aValue and (node = nil) then
        begin
          node := NodeColumns.appendChild(CreateElement('COLUMN'));
          node.setAttribute('ID', aName);
        end
      else if not aValue and (node <> nil) then
        begin
          NodeColumns.removeChild(node);
          DisposeNode(node);
        end;
    end;
end;

//*****

procedure TFrameReportParameters.setRegInfo(aRegInfo: TRegistryInfo);
var
  i, rri: Integer;
  ri: TRegistryInfo;
  rawData: TStringList;
  oldParams: TReportParameters;
begin
  if aRegInfo <> fRegInfo then
    begin
      //--- Store the registry descriptor reference
      fRegInfo := aRegInfo;

      //--- Populate the list of registries for the 'Other Registries' panel
      agRegistries.BeginUpdate;
      try
        agRegistries.RemoveAll;
        for i:=AvailableRegistries.Count-1 downto 0 do
          begin
            ri := AvailableRegistries[i];
            if ri.IEN <> RegInfo.IEN then
              with agRegistries do
                begin
                  AddRow;
                  rri := RowCount - 1;
                  GridCells[orName, rri]  := ri.Name;
                  GridCells[orDescr, rri] := ri.Description;
                  GridCells[orIEN, rri]   := ri.IEN;
                end;
          end;
      finally
        agRegistries.EndUpdate;
      end;

      //--- Populate the list of selection rules
      rawData := TStringList.Create;
      try
        cgvSelectionRules.Clear;
        if Broker.CallProc(rpcListSelectionRules,
          [RegInfo.IEN], nil, rawData) then
          begin
            rawData.Delete(0);
            cgvSelectionRules.Items.AssignRawData(rawData, [2,1,3]);
          end;
      finally
        rawData.Free;
      end;
      for i:=cgvSelectionRules.Items.Count-1 downto 0 do
        cgvSelectionRules.Items[i].Indent := 0;

      //--- Populate the list of registry Lab test groups ('3')
      fRegTests := TStringList.Create;
      if Broker.CallProc(rpcListItems, [RegInfo.IEN,'3'], nil, fRegTests) then
      begin
        fRegTests.Delete(0);
      end;

      //--- Populate the list of BMI test groups ('5')
      fBMITests := TStringList.Create;
      if Broker.CallProc(rpcListItems, [RegInfo.IEN,'5'], nil, fBMITests) then
      begin
        fBMITests.Delete(0);
      end;

      //--- Populate the list of MELD test groups ('6')
      fMELDTests := TStringList.Create;
      if Broker.CallProc(rpcListItems, [RegInfo.IEN,'6'], nil, fMELDTests) then
      begin
        fMELDTests.Delete(0);
      end;

      //--- Populate the list of Renal function test groups ('7')
      fRenalTests := TStringList.Create;
      if Broker.CallProc(rpcListItems, [RegInfo.IEN,'7'], nil, fRenalTests) then
      begin
        fRenalTests.Delete(0);
      end;

    end;

  if Assigned(RegInfo) then
    begin
      //--- Populate the list of local fields for the 'Local Fields' panel
      oldParams := TReportParameters.Create;
      rawData := TStringList.Create;
      try
        pnlParams100.GetFieldValues('', oldParams, rawData);
        rawData.Clear;
        agLocalFields.RemoveAll;
        if Broker.CallProc(rpcListLocalFields,
          [RegInfo.IEN], nil, rawData) then
          begin
            rawData.Delete(0);
            agLocalFields.AssignRawData(rawData, [-1,2,4,1]);
          end;
        pnlParams100.SetFieldValues('', oldParams);
      finally
        rawData.Free;
        oldParams.Free;
      end;
    end;
end;

//****** POPULATES VISIBLE CONTROLS WITH THE VALUES OF REPORT PARAMETERS

procedure TFrameReportParameters.SetFieldValues(const aReportCode: String;
  ReportParams: TReportParameters);
var
  i, n: Integer;
  pnlNode: TDomNode;
  sf: Boolean;
  qs: String;
begin
  //--- Find common nodes
  with ReportParams do
    begin
      fNodeDrugs    := FindNode('/PARAMS/DRUGS');
      fNodeColumns  := FindNode('/PARAMS/OPTIONAL_COLUMNS');
      fNodeOptions  := FindNode('/PARAMS/OPTIONS');
      fNodePatients := FindNode('/PARAMS/PATIENTS');
      pnlNode       := FindNode('/PARAMS/PANELS');
    end;

  //--- Populate controls of visible panels with the parameter values
  with scbxMain do
    begin
      n := ControlCount - 1;
      for i:=0 to n do
        if (Controls[i] is TCCRParamsPanel) and Controls[i].Visible then
          begin
            if Assigned(pnlNode) then
              begin
                qs := Format('PANEL[@ID="%d"]',[Controls[i].Tag]);
                sf := (pnlNode.FindNode(qs) <> nil);
              end
            else
              sf := True;
            if sf then
              TCCRParamsPanel(Controls[i]).SetFieldValues(aReportCode, ReportParams);
          end;
    end;
end;

//***** COMBINES THE PANELS REQUIRED FOR THE SELECTED REPORT

procedure TFrameReportParameters.SetupPanels(aReport: TReportDescriptor);
var
  i, n: Integer;
begin
  //--- Hide the scroll-box to reduce flicker
  scbxMain.Visible := False;
  try
    if Assigned(aReport) then
      with aReport.Panels do
        begin
          //--- Show the parameter panels associated with the report
          n := Count - 1;
          for i:=0 to n do
            with TCCRParamsPanel(Objects[i]) do
              begin
                Visible  := True;
                Enabled  := True;
                Align    := alTop;
                TabOrder := i + 1;
              end;
          for i:=0 to n do
            TCCRParamsPanel(Objects[i]).Setup(aReport.Code);
          //--- Populate the controls with the values of report parameters
          SetFieldValues(aReport.Code, aReport.Parameters);
        end
    else
      with scbxMain do
        //--- Hide all parameter panels if the report reference is not provided
        for i:=ControlCount-1 downto 0 do
          begin
            Controls[i].Align := alBottom;
            Controls[i].Visible := False;
          end;
  finally
    //--- Always restore visibility of the scroll-box
    scbxMain.Visible := True;
  end;
end;

//***** UPDATES THE REFERENCES OF PANELS ASSOCIATED WITH THE REPORTS

procedure TFrameReportParameters.UpdatePanelReferences;
var
  i, iRep, iTag, lastCtrl: Integer;
  pnlTag: Longint;
  tmp: String;
  ctrl: TControl;
begin
  lastCtrl := scbxMain.ControlCount - 1;
  //--- Browse the available report descriptors
  for iRep:= RegInfo.AvailableReports.Count-1 downto 0 do
    with RegInfo.AvailableReports[iRep] do
      begin
        //--- Clear the list of old panel references
        Panels.Clear;
        //--- Build the new list
        iTag := 0;
        while True do
          begin
            Inc(iTag);
            //--- Get the panel tag from the report definition
            tmp := Piece(PanelTags, ',', iTag);
            if tmp = '' then Break;
            pnlTag := StrToIntDef(tmp, 0);
            if pnlTag <= 0 then Break;
            //--- Find the corresponding panel and add the reference to the list
            for i:=0 to lastCtrl do
              begin
                ctrl := scbxMain.Controls[i];
                if (ctrl is TCCRParamsPanel) and (ctrl.Tag = pnlTag) then
                  Panels.AddObject(IntToStr(pnlTag), ctrl);
              end;
          end;
      end;
end;

//***** VALIDATES THE (RE)SCHEDULING CODE

function TFrameReportParameters.validateScheduleCode(const aCode: String;
  const aDateTime: TDateTime): Boolean;
var
  rawData: TStringList;
begin
  Result := True;
  rawData := TStringList.Create;
  try
    if Broker.CallProc('ROR TASK VALIDATE RESCHEDULING',
      [aCode, FloatToStr(WindowsDateTimeToFMDateTime(aDateTime))],
      nil, rawData, [rpcSilent]) then
        Result := (StrToIntDef(Piece(rawData[0],U), 0) > 0);
  finally
    rawData.Free;
  end;
end;

procedure TFrameReportParameters.vxsComponentStateRestoreState(Sender: TObject);
var
  storage: TOvcAbstractStore;
begin
  storage := TOvcComponentState(Sender).Storage;
  if Assigned(storage) then
    begin
      ccrDivisionSelector.LoadLayout(storage, ssDivisionSelector);
      agLabRanges.LoadLayout(storage, ssLabRanges);
      ccrClinicSelector.LoadLayout(storage, ssClinicSelector);
      ccrLabTestSelector.LoadLayout(storage, ssLabTestSelector);
      ccrLTRSelector.LoadLayout(storage, ssLTRSelector);
      ccrICD9Selector.LoadLayout(storage, ssICD9Selector);
      ccrCPTSelector.LoadLayout(storage, ssCPTSelector);
      agRegistries.LoadLayout(storage, ssRegistries);
      agLocalFields.LoadLayout(storage, ssLocalFields);
      ccrDrugSelector.LoadLayout(storage, ssDrugSelector);
      ccrPatientSelector.LoadLayout(storage, ssPatientSelector);
    end;
end;

procedure TFrameReportParameters.vxsComponentStateSaveState(Sender: TObject);
var
  storage: TOvcAbstractStore;
begin
  storage := TOvcComponentState(Sender).Storage;
  if Assigned(storage) then
    begin
      ccrDivisionSelector.SaveLayout(storage, ssDivisionSelector);
      agLabRanges.SaveLayout(storage, ssLabRanges);
      ccrClinicSelector.SaveLayout(storage, ssClinicSelector);
      ccrLabTestSelector.SaveLayout(storage, ssLabTestSelector);
      ccrLTRSelector.SaveLayout(storage, ssLTRSelector);
      ccrICD9Selector.SaveLayout(storage, ssICD9Selector);
      ccrCPTSelector.SaveLayout(storage, ssCPTSelector);
      agRegistries.SaveLayout(storage, ssRegistries);
      agLocalFields.SaveLayout(storage, ssLocalFields);
      ccrDrugSelector.SaveLayout(storage, ssDrugSelector);
      ccrPatientSelector.SaveLayout(storage, ssPatientSelector);
    end;
end;

//***** Shared routine to enable/disable checkbox when user types in column

procedure TFrameReportParameters.agRangesSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
var
  cbs: Boolean;
begin
  with Sender as TCCRAdvColGrid do
    if ARow >= FixedRows then
      begin
        if ACol <> lrgToggle then
          begin
            GetCheckBoxState(lrgToggle, ARow, cbs);
            if Not cbs then
              begin
                SetCheckBoxState(lrgToggle, ARow, True);
                RepaintCell(DisplColIndex(lrgToggle), DisplRowIndex(ARow));
              end;
          end;
      end;
end;

///////////////////////////// Parameters Panel #010 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams010ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteNode('/PARAMS/DATE_RANGE');
end;

procedure TFrameReportParameters.pnlParams010GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
var
  dtFrom, dtTo: Double;
  dtQuarter, dtYear: Integer;
  params: TReportParameters;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  node := params.GetNode('/PARAMS/DATE_RANGE');

  if rbCustom.Checked then
    begin
      dtFrom := WindowsDateToFMDate(Trunc(dtpFrom.Date));
      dtTo   := WindowsDateToFMDate(Trunc(dtpTo.Date));
      if dtFrom > dtTo then
        begin
          aMsgLst.Add(RSC00201);
          aField := dtpFrom;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     FloatToStr(dtTo));
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   FloatToStr(dtFrom));
          SetAttrVal(node, dtrsType,    dtrsCustom);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbCutOff.Checked then
    begin
      if edCutOff.Text = '' then
        begin
          aMsgLst.Add(RSC00202);
          aField := edCutOff;
        end
      else if not isCutOffValid(edCutOff.Text) then
        begin
          aMsgLst.Add(RSC00210);
          aField := edCutOff;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  edCutOff.Text);
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsCutOff);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbQuarter.Checked then
    begin
      dtYear := StrToIntDef(edYear.Text, 0);
      dtQuarter := cbQuarter.ItemIndex + 1;
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear;
        end;
      if (dtQuarter < 1) or (dtQuarter > 4) then
        begin
          aMsgLst.Add(RSC00204);
          if not Assigned(aField) then
            aField := cbQuarter;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal.Checked);
          SetAttrVal(node, dtrsQuarter, IntToStr(dtQuarter));
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsQuarter);
          if dtYear > 0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end
  else if rbYear.Checked then
    begin
      dtYear := StrToIntDef(edYear.Text, 0);
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal.Checked);
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsYear);
          if dtYear >0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams010Setup(const aReportCode: String);
begin
  if aReportCode = '12' then
    pnlParams010.Caption := 'Medications Date Range'
  else
    pnlParams010.Caption := 'Date Range';
end;

procedure TFrameReportParameters.pnlParams010SetValues(const aReportCode: String; aList: TCustomReportParameters);
var
  dtrType: String;
  dt, i: Integer;
  node: TDomNode;
  params: TReportParameters;
begin
  cbFiscal.Checked := False;
  params := TReportParameters(aList);

  node := params.FindNode('/PARAMS/DATE_RANGE');
  if Assigned(node) then
    dtrType := params.GetAttrStr(node, dtrsType)
  else
    dtrType := '';

  if dtrType = dtrsCustom then
    begin
      rbCustom.Checked := True;
      // Custom 'From' date
      try
        dt := params.GetAttrInt(node, dtrsStart);
        dtpFrom.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpFrom.Date := Date;
      end;
      // Custom 'To' date
      try
        dt := params.GetAttrInt(node, dtrsEnd);
        dtpTo.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpTo.Date := Date;
      end;
    end
  else if dtrType = dtrsCutOff then
    begin
      rbCutOff.Checked := True;
      edCutOff.Text := params.GetAttrStr(node, dtrsCutOff);
    end
  else if dtrType = dtrsQuarter then
    begin
      rbQuarter.Checked := True;
      i := params.GetAttrInt(node, dtrsQuarter);
      if (i >= 1) and (i <= 4) then
        cbQuarter.ItemIndex := i - 1
      else
        cbQuarter.ItemIndex := -1;
      edYear.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal.Checked := True;
    end
  else if dtrType = dtrsYear then
    begin
      rbYear.Checked := True;
      edYear.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal.Checked := True;
    end
  else
    begin
      rbYear.Checked := True;
      edYear.Text := '';
    end;
end;

procedure TFrameReportParameters.rbDateRangeClick(Sender: TObject);
begin
  cbQuarter.Enabled := (Sender = rbQuarter);
  edYear.Enabled    := (Sender = rbYear) or cbQuarter.Enabled;
  cbFiscal.Enabled  := edYear.Enabled;
  edCutOff.Enabled  := (Sender = rbCutOff);

  if Sender = rbCustom then
    begin
      dtpFrom.Enabled := True;
      dtpTo.Enabled   := True;
      spbMax.Enabled  := True;
      spbMin.Enabled  := True;
    end
  else
    begin
      dtpFrom.Enabled := False;
      dtpTo.Enabled   := False;
      spbMax.Enabled  := False;
      spbMin.Enabled  := False;
    end;

  cbQuarter.Color := CtrlColor(cbQuarter.Enabled);
  dtpFrom.Color   := CtrlColor(dtpFrom.Enabled);
  dtpTo.Color     := CtrlColor(dtpTo.Enabled);
end;

procedure TFrameReportParameters.spbMaxClick(Sender: TObject);
begin
  dtpTo.Date := Date;
end;

procedure TFrameReportParameters.spbMinClick(Sender: TObject);
begin
  dtpFrom.Date := dtpFrom.MinDate;
end;

///////////////////////////// Parameters Panel #011 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams011ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteNode('/PARAMS/DATE_RANGE_2');
end;

procedure TFrameReportParameters.pnlParams011GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
var
  dtFrom, dtTo: Double;
  dtQuarter, dtYear: Integer;
  params: TReportParameters;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  node := params.GetNode('/PARAMS/DATE_RANGE_2');

  if rbCustom011.Checked then
    begin
      dtFrom := WindowsDateToFMDate(Trunc(dtpFrom011.Date));
      dtTo   := WindowsDateToFMDate(Trunc(dtpTo011.Date));
      if dtFrom > dtTo then
        begin
          aMsgLst.Add(RSC00201);
          aField := dtpFrom011;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     FloatToStr(dtTo));
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   FloatToStr(dtFrom));
          SetAttrVal(node, dtrsType,    dtrsCustom);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbCutOff011.Checked then
    begin
      if edCutOff011.Text = '' then
        begin
          aMsgLst.Add(RSC00202);
          aField := edCutOff011;
        end
      else if not isCutOffValid(edCutOff011.Text) then
        begin
          aMsgLst.Add(RSC00210);
          aField := edCutOff011;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  edCutOff011.Text);
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsCutOff);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbQuarter011.Checked then
    begin
      dtYear := StrToIntDef(edYear011.Text, 0);
      dtQuarter := cbQuarter011.ItemIndex + 1;
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear011;
        end;
      if (dtQuarter < 1) or (dtQuarter > 4) then
        begin
          aMsgLst.Add(RSC00204);
          if not Assigned(aField) then
            aField := cbQuarter011;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal011.Checked);
          SetAttrVal(node, dtrsQuarter, IntToStr(dtQuarter));
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsQuarter);
          if dtYear > 0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end
  else if rbYear011.Checked then
    begin
      dtYear := StrToIntDef(edYear011.Text, 0);
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear011;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal011.Checked);
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsYear);
          if dtYear >0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams011SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
var
  dtrType: String;
  dt, i: Integer;
  node: TDomNode;
  params: TReportParameters;
begin
  cbFiscal011.Checked := False;
  params := TReportParameters(aList);

  node := params.FindNode('/PARAMS/DATE_RANGE_2');
  if Assigned(node) then
    dtrType := params.GetAttrStr(node, dtrsType)
  else
    dtrType := '';

  if dtrType = dtrsCustom then
    begin
      rbCustom011.Checked := True;
      // Custom 'From' date
      try
        dt := params.GetAttrInt(node, dtrsStart);
        dtpFrom011.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpFrom011.Date := Date;
      end;
      // Custom 'To' date
      try
        dt := params.GetAttrInt(node, dtrsEnd);
        dtpTo011.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpTo011.Date := Date;
      end;
    end
  else if dtrType = dtrsCutOff then
    begin
      rbCutOff011.Checked := True;
      edCutOff011.Text := params.GetAttrStr(node, dtrsCutOff);
    end
  else if dtrType = dtrsQuarter then
    begin
      rbQuarter011.Checked := True;
      i := params.GetAttrInt(node, dtrsQuarter);
      if (i >= 1) and (i <= 4) then
        cbQuarter011.ItemIndex := i - 1
      else
        cbQuarter011.ItemIndex := -1;
      edYear011.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal011.Checked := True;
    end
  else if dtrType = dtrsYear then
    begin
      rbYear011.Checked := True;
      edYear011.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal011.Checked := True;
    end
  else
    begin
      rbYear011.Checked := True;
      edYear011.Text := '';
    end;
end;

procedure TFrameReportParameters.rbDateRange011Click(Sender: TObject);
begin
  cbQuarter011.Enabled := (Sender = rbQuarter011);
  edYear011.Enabled    := (Sender = rbYear011) or cbQuarter011.Enabled;
  cbFiscal011.Enabled  := edYear011.Enabled;
  edCutOff011.Enabled  := (Sender = rbCutOff011);

  if Sender = rbCustom011 then
    begin
      dtpFrom011.Enabled := True;
      dtpTo011.Enabled   := True;
      spbMax011.Enabled  := True;
      spbMin011.Enabled  := True;
    end
  else
    begin
      dtpFrom011.Enabled := False;
      dtpTo011.Enabled   := False;
      spbMax011.Enabled  := False;
      spbMin011.Enabled  := False;
    end;

  cbQuarter011.Color := CtrlColor(cbQuarter011.Enabled);
  dtpFrom011.Color   := CtrlColor(dtpFrom011.Enabled);
  dtpTo011.Color     := CtrlColor(dtpTo011.Enabled);
end;

procedure TFrameReportParameters.spbMax011Click(Sender: TObject);
begin
  dtpTo011.Date := Date;
end;

procedure TFrameReportParameters.spbMin011Click(Sender: TObject);
begin
  dtpFrom011.Date := dtpFrom011.MinDate;
end;

///////////////////////////// Parameters Panel #012 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams012ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteNode('/PARAMS/DATE_RANGE_3');
end;

procedure TFrameReportParameters.pnlParams012GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
var
  dtFrom, dtTo: Double;
  dtQuarter, dtYear: Integer;
  params: TReportParameters;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  node := params.GetNode('/PARAMS/DATE_RANGE_3');

  if rbCustom012.Checked then
    begin
      dtFrom := WindowsDateToFMDate(Trunc(dtpFrom012.Date));
      dtTo   := WindowsDateToFMDate(Trunc(dtpTo012.Date));
      if dtFrom > dtTo then
        begin
          aMsgLst.Add(RSC00201);
          aField := dtpFrom012;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     FloatToStr(dtTo));
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   FloatToStr(dtFrom));
          SetAttrVal(node, dtrsType,    dtrsCustom);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbCutOff012.Checked then
    begin
      if edCutOff012.Text = '' then
        begin
          aMsgLst.Add(RSC00202);
          aField := edCutOff012;
        end
      else if not isCutOffValid(edCutOff012.Text) then
        begin
          aMsgLst.Add(RSC00210);
          aField := edCutOff012;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  edCutOff012.Text);
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  '');
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsCutOff);
          SetAttrVal(node, dtrsYear,    '');
        end;
    end
  else if rbQuarter012.Checked then
    begin
      dtYear := StrToIntDef(edYear012.Text, 0);
      dtQuarter := cbQuarter012.ItemIndex + 1;
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear012;
        end;
      if (dtQuarter < 1) or (dtQuarter > 4) then
        begin
          aMsgLst.Add(RSC00204);
          if not Assigned(aField) then
            aField := cbQuarter012;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal012.Checked);
          SetAttrVal(node, dtrsQuarter, IntToStr(dtQuarter));
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsQuarter);
          if dtYear > 0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end
  else if rbYear012.Checked then
    begin
      dtYear := StrToIntDef(edYear012.Text, 0);
      if dtYear <= 0 then
        begin
          aMsgLst.Add(RSC00203);
          aField := edYear012;
        end;
      with params do
        begin
          SetAttrVal(node, dtrsCutOff,  '');
          SetAttrVal(node, dtrsEnd,     '');
          SetAttrVal(node, dtrsFiscal,  cbFiscal012.Checked);
          SetAttrVal(node, dtrsQuarter, '');
          SetAttrVal(node, dtrsStart,   '');
          SetAttrVal(node, dtrsType,    dtrsYear);
          if dtYear >0 then
            SetAttrVal(node, dtrsYear,  IntToStr(dtYear))
          else
            SetAttrVal(node, dtrsYear,  '');
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams012SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
var
  dtrType: String;
  dt, i: Integer;
  node: TDomNode;
  params: TReportParameters;
begin
  cbFiscal012.Checked := False;
  params := TReportParameters(aList);

  node := params.FindNode('/PARAMS/DATE_RANGE_3');
  if Assigned(node) then
    dtrType := params.GetAttrStr(node, dtrsType)
  else
    dtrType := '';

  if dtrType = dtrsCustom then
    begin
      rbCustom012.Checked := True;
      // Custom 'From' date
      try
        dt := params.GetAttrInt(node, dtrsStart);
        dtpFrom012.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpFrom012.Date := Date;
      end;
      // Custom 'To' date
      try
        dt := params.GetAttrInt(node, dtrsEnd);
        dtpTo012.Date := FMDateTimeToWindowsDateTime(dt);
      except
        dtpTo012.Date := Date;
      end;
    end
  else if dtrType = dtrsCutOff then
    begin
      rbCutOff012.Checked := True;
      edCutOff012.Text := params.GetAttrStr(node, dtrsCutOff);
    end
  else if dtrType = dtrsQuarter then
    begin
      rbQuarter012.Checked := True;
      i := params.GetAttrInt(node, dtrsQuarter);
      if (i >= 1) and (i <= 4) then
        cbQuarter012.ItemIndex := i - 1
      else
        cbQuarter012.ItemIndex := -1;
      edYear012.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal012.Checked := True;
    end
  else if dtrType = dtrsYear then
    begin
      rbYear012.Checked := True;
      edYear012.Text := params.GetAttrStr(node, dtrsYear);
      if params.GetAttrBool(node, dtrsFiscal) then
        cbFiscal012.Checked := True;
    end
  else
    begin
      rbYear012.Checked := True;
      edYear012.Text := '';
    end;
end;

procedure TFrameReportParameters.rbDateRange012Click(Sender: TObject);
begin
  cbQuarter012.Enabled := (Sender = rbQuarter012);
  edYear012.Enabled    := (Sender = rbYear012) or cbQuarter012.Enabled;
  cbFiscal012.Enabled  := edYear012.Enabled;
  edCutOff012.Enabled  := (Sender = rbCutOff012);

  if Sender = rbCustom012 then
    begin
      dtpFrom012.Enabled := True;
      dtpTo012.Enabled   := True;
      spbMax012.Enabled  := True;
      spbMin012.Enabled  := True;
    end
  else
    begin
      dtpFrom012.Enabled := False;
      dtpTo012.Enabled   := False;
      spbMax012.Enabled  := False;
      spbMin012.Enabled  := False;
    end;

  cbQuarter012.Color := CtrlColor(cbQuarter012.Enabled);
  dtpFrom012.Color   := CtrlColor(dtpFrom012.Enabled);
  dtpTo012.Color     := CtrlColor(dtpTo012.Enabled);
end;

procedure TFrameReportParameters.spbMax012Click(Sender: TObject);
begin
  dtpTo012.Date := Date;
end;

procedure TFrameReportParameters.spbMin012Click(Sender: TObject);
begin
  dtpFrom012.Date := dtpFrom012.MinDate;
end;

///////////////////////////// Parameters Panel #014 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams014GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  TReportParameters(aList).SetNodeVal('/PARAMS/TASK_COMMENT', edTaskComment.Text);
  if not validateScheduleCode(cmbbSchedule.Text, getDTRun) then
    begin
      aMsgLst.Add(RSC00205);
      aField := cmbbSchedule;
    end;
end;

procedure TFrameReportParameters.pnlParams014SetValues(const aReportCode: String; aList: TCustomReportParameters);
var
  dtn: TDateTime;
begin
  cmbbSchedule.Text      := '';
  edTaskComment.Text     := TReportParameters(aList).GetNodeVal('/PARAMS/TASK_COMMENT');

  dtn := GetServerDateTime();
  dtpScheduleDay.Date    := DateOf(dtn);
  dtpScheduleDay.MinDate := dtpScheduleDay.Date;
  dtpScheduleTime.Time   := TimeOf(dtn);
end;

///////////////////////////// Parameters Panel #020 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams020GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodePatients, 'CONFIRMED', cbConfirmed.Checked);
      SetAttrVal(NodePatients, 'PENDING',   cbPending.Checked);
    end;
  if not (cbConfirmed.Checked or cbPending.Checked) then
    begin
      aMsgLst.Add(RSC00206);
      aField := cbConfirmed;
    end;
end;

procedure TFrameReportParameters.pnlParams020SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbConfirmed.Checked := GetAttrBool(NodePatients, 'CONFIRMED');
      cbPending.Checked   := GetAttrBool(NodePatients, 'PENDING');
    end;
end;

procedure TFrameReportParameters.cbPendingClick(Sender: TObject);
begin
  cbPendingComments.Enabled := cbPending.Checked;
  if not cbPending.Checked then
    cbPendingComments.Checked := false;
end;

///////////////////////////// Parameters Panel #022 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams022GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodePatients, 'DE_AFTER',  cbAfter.Checked);
      SetAttrVal(NodePatients, 'DE_BEFORE', cbBefore.Checked);
      SetAttrVal(NodePatients, 'DE_DURING', cbDuring.Checked);
    end;
  if not (cbBefore.Checked or cbDuring.Checked or cbAfter.Checked) then
    begin
      aMsgLst.Add(RSC00206);
      aField := cbBefore;
    end;
end;

procedure TFrameReportParameters.pnlParams022SetValues(const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbAfter.Checked  := GetAttrBool(NodePatients, 'DE_AFTER');
      cbBefore.Checked := GetAttrBool(NodePatients, 'DE_BEFORE');
      cbDuring.Checked := GetAttrBool(NodePatients, 'DE_DURING');
    end;
end;

///////////////////////////// Parameters Panel #026 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams026GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodePatients, 'INPATIENT',  cbInpatient.Checked);
      SetAttrVal(NodePatients, 'OUTPATIENT', cbOutpatient.Checked);
    end;
  if not (cbInpatient.Checked or cbOutpatient.Checked) then
    begin
      aMsgLst.Add(RSC00206);
      aField := cbInpatient;
    end;
end;

procedure TFrameReportParameters.pnlParams026SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbInpatient.Checked  := GetAttrBool(NodePatients, 'INPATIENT');
      cbOutpatient.Checked := GetAttrBool(NodePatients, 'OUTPATIENT');
    end;
end;

///////////////////////////// Parameters Panel #028 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams028GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodeOptions,  'REGMEDSMRY', cbRegMedSMRY.Checked);
      SetAttrVal(NodeOptions,  'PTLIST',     cbVERAPtList.Checked);
      SetAttrVal(NodePatients, 'BASIC',      cbVERABasic.Checked);
      SetAttrVal(NodePatients, 'COMPLEX',    cbVERAComplex.Checked);
    end;
  if not (cbVERABasic.Checked or cbVERAComplex.Checked) then
    begin
      aMsgLst.Add(RSC00207);
      aField := cbVERAComplex;
    end;
end;

procedure TFrameReportParameters.pnlParams028SetValues(const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbRegMedSMRY.Checked  := GetAttrBool(NodeOptions,  'REGMEDSMRY');
      cbVERAPtList.Checked  := GetAttrBool(NodeOptions,  'PTLIST');
      cbVERABasic.Checked   := GetAttrBool(NodePatients, 'BASIC');
      cbVERAComplex.Checked := GetAttrBool(NodePatients, 'COMPLEX');
    end;
end;

///////////////////////////// Parameters Panel #030 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams030GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  setColumnOption('AGE',      cbAge.Checked);
  setColumnOption('CONFDT',   cbDateConf.Checked);
  setColumnOption('DOB',      cbDateOfBirth.Checked);
  setColumnOption('DOD',      cbDateOfDeath.Checked);
  setColumnOption('RACE',     cbRace.Checked);
  setColumnOption('SELDT',    cbDateSel.Checked);
  setColumnOption('SEX',      cbSex.Checked);
  setColumnOption('SSN',      cbSSN.Checked);
  setColumnOption('UTIL',     cbUtilization.Checked);

  if RegInfo.Name = 'VA HIV' then
    setColumnOption('RISK',   cbRisk.Checked)
  else
    setColumnOption('RISK',   False);
end;

procedure TFrameReportParameters.pnlParams030SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  cbAge.Checked         := getColumnOption('AGE');
  cbDateConf.Checked    := getColumnOption('CONFDT');
  cbDateOfBirth.Checked := getColumnOption('DOB');
  cbDateOfDeath.Checked := getColumnOption('DOD');
  cbRace.Checked        := getColumnOption('RACE');
  cbDateSel.Checked     := getColumnOption('SELDT');
  cbSex.Checked         := getColumnOption('SEX');
  cbSSN.Checked         := getColumnOption('SSN');
  cbUtilization.Checked := getColumnOption('UTIL');

  if RegInfo.Name = 'VA HIV' then
    begin
      cbRisk.Enabled    := True;
      cbRisk.Checked    := getColumnOption('RISK');
    end
  else
    begin
      cbRisk.Enabled    := False;
      cbRisk.Checked    := False;
    end;
end;

///////////////////////////// Parameters Panel #032 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams032GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  setColumnOption('CSSN',     cbCSSN.Checked);
  setColumnOption('CONFDT',   cbDateConfirmed.Checked);
  setColumnOption('DOD',      cbDOD.Checked);
  setColumnOption('SELDT',    cbDateSelected.Checked);
  setColumnOption('LAST4',    cbLast4.Checked);
  setColumnOption('SELRULES', cbSelRules.Checked);
  setColumnOption('PENDCOMM', cbPendingComments.Checked);
end;

procedure TFrameReportParameters.pnlParams032SetValues(const aReportCode: String; aList: TCustomReportParameters);
begin
  cbCSSN.Checked            := getColumnOption('CSSN');
  cbDateConfirmed.Checked   := getColumnOption('CONFDT');
  cbDOD.Checked             := getColumnOption('DOD');
  cbDateSelected.Checked    := getColumnOption('SELDT');
  cbLast4.Checked           := getColumnOption('LAST4');
  cbSelRules.Checked        := getColumnOption('SELRULES');
  cbPendingComments.Checked := getColumnOption('PENDCOMM');
end;

///////////////////////////// Parameters Panel #034 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrDivisionSelectorSplitterMoved(
  Sender: TObject);
begin
  cseDivisionSearch.SetBounds(41, 0, ccrDivisionSelector.SourceList.Width-41,
    pnlDivisionSearch.ClientHeight);
end;

procedure TFrameReportParameters.cseDivisionSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
begin
  with cseDivisionSearch do
    SetParams([Text,'','20','']);
end;

procedure TFrameReportParameters.pnlParams034GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/DIVISIONS');
      if rbDivisionsAll.Checked then
        begin
          SetAttrVal(group, 'ALL', True);
          DeleteChildren(group);
        end
      else
        with ccrDivisionSelector do
          begin
            SetAttrVal(group, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(group);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(group, 'DIV', AsString[1]);
                      SetAttrVal(node, 'ID', AsString[0]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00208);
                aField := cseDivisionSearch;
              end;
          end;
    end;
end;

procedure TFrameReportParameters.pnlParams034SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbDivisionsAll.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/DIVISIONS');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        begin
          loadSelectorResult(ccrDivisionSelector, group, ['ID','*']);
          if ccrDivisionSelector.ResultList.Items.Count > 0 then
            rbDivisionsSelected.Checked := True;
        end;
    end;
end;

///////////////////////////// Parameters Panel #035 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams035GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  utilTypes: TDomNode;

  procedure setUtilType(const aName: String; aValue: Boolean);
    var
      node: TDomNode;
  begin
    with utilTypes.OwnerDocument do
      begin
        node := utilTypes.FindNode('UT[@ID="'+aName+'"]');
        if aValue and (node = nil) then
          begin
            node := utilTypes.appendChild(CreateElement('UT'));
            node.setAttribute('ID', aName);
          end
        else if not aValue and (node <> nil) then
          begin
            utilTypes.removeChild(node);
            DisposeNode(node);
          end;
      end;
  end;

begin
  utilTypes := TReportParameters(aList).GetNode('/PARAMS/UTIL_TYPES');

  if rbUTSelected.Checked then
    begin
      utilTypes.removeAttribute('ALL');
      setUtilType('A',  cbUTAllergy.Checked);
      setUtilType('C',  cbUTCytopathology.Checked);
      setUtilType('I',  cbUTInpatient.Checked);
      setUtilType('IP', cbUTPharmacyIP.Checked);
      setUtilType('IV', cbUTPharmacyIV.Checked);
      setUtilType('L',  cbUTLaboratory.Checked);
      setUtilType('M',  cbUTMicrobiology.Checked);
      setUtilType('O',  cbUTOutpatient.Checked);
      setUtilType('OP', cbUTPharmacyOP.Checked);
      setUtilType('R',  cbUTRadiology.Checked);
      setUtilType('SP', cbUTSurgPath.Checked);
    end
  else
    begin
      TReportParameters(aList).DeleteChildren(utilTypes);
      utilTypes.setAttribute('ALL', '1');
    end;
end;

procedure TFrameReportParameters.pnlParams035SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  utilTypes: TDomNode;

  function getUtilType(const aName: String): Boolean;
  begin
    if Assigned(utilTypes) then
      Result := (utilTypes.FindNode('UT[@ID="'+aName+'"]') <> nil)
    else
      Result := False;
  end;

begin
  utilTypes := TReportParameters(aList).FindNode('/PARAMS/UTIL_TYPES');

  if Assigned(utilTypes) and (utilTypes.getAttribute('ALL') <> '1') then
    begin
      rbUTSelected.Checked := True;
      cbUTAllergy.Checked       := getUtilType('A');
      cbUTCytopathology.Checked := getUtilType('C');
      cbUTInpatient.Checked     := getUtilType('I');
      cbUTPharmacyIP.Checked    := getUtilType('IP');
      cbUTPharmacyIV.Checked    := getUtilType('IV');
      cbUTLaboratory.Checked    := getUtilType('L');
      cbUTMicrobiology.Checked  := getUtilType('M');
      cbUTOutpatient.Checked    := getUtilType('O');
      cbUTPharmacyOP.Checked    := getUtilType('OP');
      cbUTRadiology.Checked     := getUtilType('R');
      cbUTSurgPath.Checked      := getUtilType('SP');
    end
  else
    rbUTAll.Checked := True;
end;

///////////////////////////// Parameters Panel #042 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams042GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodeDrugs, 'REGSPEC',  cbRegistryDrugs042.Checked);
      SetAttrVal(NodeDrugs, 'INVESTIG', cbInvestigDrugs042.Checked);
    end
end;

procedure TFrameReportParameters.pnlParams042SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbRegistryDrugs042.Checked := GetAttrBool(NodeDrugs, 'REGSPEC');
      cbInvestigDrugs042.Checked := GetAttrBool(NodeDrugs, 'INVESTIG');
    end
end;

///////////////////////////// Parameters Panel #044 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams044ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  with NodeDrugs do
    begin
      removeAttribute('AGGR_FORMUL');
      removeAttribute('AGGR_GENERIC');
    end;
end;

procedure TFrameReportParameters.pnlParams044GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodeDrugs, 'AGGR_FORMUL',  rbDispensedDrugs044.Checked);
      SetAttrVal(NodeDrugs, 'AGGR_GENERIC', rbGenericDrugs044.Checked);
    end
end;

procedure TFrameReportParameters.pnlParams044SetValues(const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    if GetAttrBool(NodeDrugs, 'AGGR_FORMUL') then
      rbDispensedDrugs044.Checked := True
    else
      rbGenericDrugs044.Checked := True;
end;

///////////////////////////// Parameters Panel #046 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams046GetValues(const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    if rbDetailsUsers.Checked then
      begin
        SetNodeVal('/PARAMS/MAXUTNUM', edHighestUtilNum046.Text);
        if edHighestUtilNum046.Text = '' then
          begin
            aMsgLst.Add(RSC00211);
            aField := edHighestUtilNum046;
          end;
      end
    else
      DeleteNode('/PARAMS/MAXUTNUM');
end;

procedure TFrameReportParameters.pnlParams046SetValues(const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    edHighestUtilNum046.Text := GetNodeVal('/PARAMS/MAXUTNUM');
  if edHighestUtilNum046.Text <> '' then
    rbDetailsUsers.Checked := True
  else
    rbSummaryUsers.Checked := True;
end;

procedure TFrameReportParameters.rbDetailsUsersClick(Sender: TObject);
begin
  edHighestUtilNum046.Enabled := True;
end;

procedure TFrameReportParameters.rbSummaryUsersClick(Sender: TObject);
begin
  with edHighestUtilNum046 do
    begin
      Enabled := False;
      Text    := '';
    end;
end;

///////////////////////////// Parameters Panel #047 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.agLabRangesCheckBoxClick(Sender: TObject;
  ACol, ARow: Integer; State: Boolean);
var
  rri: Integer;
begin
  agLabRanges.HideColumn(lrgGroupCode);
  with agLabRanges do
    if not State and (RealColIndex(ACol) = lrgToggle) then
      begin
        rri := RealRowIndex(ARow);
        AllCells[lrgLow,rri]  := '';
        AllCells[lrgHigh,rri] := '';
      end;
end;

procedure TFrameReportParameters.pnlParams047GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i: Integer;
  group, node: TDomNode;
  state: Boolean;
  low, high: String;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/LRGRANGES');
      DeleteChildren(group);
      for i:=agLabRanges.RowCount-1 downto agLabRanges.FixedRows do
        begin
          agLabRanges.GetCheckBoxState(lrgToggle, i, state);
          if state then
            begin
              node := AppendNode(group, 'LRGRANGE', agLabRanges.AllCells[lrgGroupName,i]);
              SetAttrVal(node, 'USE',  '1');
              SetAttrVal(node, 'ID',   agLabRanges.GridCells[lrgGroupCode,i]);
              low  := agLabRanges.AllCells[lrgLow,i];
              high := agLabRanges.AllCells[lrgHigh,i];
              SetAttrVal(node, 'LOW',  low);
              SetAttrVal(node, 'HIGH', high);
              if not checkRange(low, high) then
                begin
                  aMsgLst.Add(RSC00212);
                  aField := agLabRanges;
                  Break;
                end;
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams047Setup(const aReportCode: string);
begin
  if (aReportCode = '10') then
  begin
    loadResultRangeGrid(agLabRanges, fRegTests, 'Lab Test Group');
    AdvPanel1.Text := 'For this report to work, lists of registry-specific Lab '
      + 'tests (Lab Tests tab of the Site Parameters) must be current!';
    pnlParams047.HelpContext := 530;
  end
  else if (aReportCode = '18') then
  begin
    loadResultRangeGrid(agLabRanges, fBMITests, 'BMI Range');
    AdvPanel1.Text := '';
    pnlParams047.HelpContext := 582;
  end
  else if (aReportCode = '19') then
  begin
    loadResultRangeGrid(agLabRanges, fMELDTests, 'MELD Score Range');
    AdvPanel1.Text := 'Lab tests used to calculate MELD scores are identified '
      + 'by LOINC code. Your local lab ADPAC should be contacted regarding '
      + 'errors in LOINC codes.';
    pnlParams047.HelpContext := 583;
  end
  else if (aReportCode = '20') then
  begin
    loadResultRangeGrid(agLabRanges, fRenalTests, 'Renal Function Range');
    AdvPanel1.Text := '';
    pnlParams047.HelpContext := 584;
  end;
end;

procedure TFrameReportParameters.pnlParams047SetValues(const aReportCode: String;
  aList: TCustomReportParameters);

procedure clearItem(const aRow: Integer);
begin
  with agLabRanges do
    begin
      SetCheckBoxState(lrgToggle, aRow, False);
      AllCells[lrgLow,aRow]  := '';
      AllCells[lrgHigh,aRow] := '';
    end;
end;

var
  i: Integer;
  group, node: TDomNode;
  query, val: String;
begin
  if agLabRanges.RowCount > 1 then
    begin
      agLabRanges.BeginUpdate;
      with TReportParameters(aList) do
        try
          group := FindNode('/PARAMS/LRGRANGES');
          if Assigned(group) then
            for i:=agLabRanges.RowCount-1 downto agLabRanges.FixedRows do
              begin
                query := 'LRGRANGE[@ID=' + agLabRanges.AllCells[lrgGroupCode,i] + ']';
                node := group.FindNode(query);
                if Assigned(node) then
                  with agLabRanges do
                    begin
                      val := node.getAttribute('USE');
                      SetCheckBoxState(lrgToggle, i, StrToBoolDef(val,False));
                      AllCells[lrgLow, i]  := node.getAttribute('LOW');
                      AllCells[lrgHigh, i] := node.getAttribute('HIGH');
                    end
                else
                  clearItem(i);
              end
          else
            for i:=agLabRanges.RowCount-1 downto agLabRanges.FixedRows do
              clearItem(i);
        finally
          agLabRanges.EndUpdate;
        end;
    end
  else
    begin
      pnlParams047.Align   := alBottom;
      pnlParams047.Visible := False;
    end;
end;

///////////////////////////// Parameters Panel #050 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrClinicSelectorSplitterMoved(
  Sender: TObject);
begin
  cseClinicSearch.SetBounds(41, 0, ccrClinicSelector.SourceList.Width-41,
    pnlClinicSearch.ClientHeight);
end;

procedure TFrameReportParameters.cseClinicSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
begin
  with cseClinicSearch do
    SetParams(['C','0',cseClinicSearch.Text,'AI','20','']);
end;

procedure TFrameReportParameters.pnlParams050GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/CLINICS');
      if rbClinicsAll.Checked then
        begin
          SetAttrVal(group, 'ALL', True);
          DeleteChildren(group);
        end
      else
        with ccrClinicSelector do
          begin
            SetAttrVal(group, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(group);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(group, 'CLINIC', AsString[1]);
                      SetAttrVal(node, 'ID', AsString[0]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00214);
                aField := cseClinicSearch;
              end;
          end;
    end;
end;

procedure TFrameReportParameters.pnlParams050SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbClinicsAll.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/CLINICS');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        begin
          loadSelectorResult(ccrClinicSelector, group, ['ID','*']);
          if ccrClinicSelector.ResultList.Items.Count > 0 then
            rbClinicsSelected.Checked := True;
        end;
    end;
end;

///////////////////////////// Parameters Panel #052 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrLabTestSelectorSplitterMoved(
  Sender: TObject);
begin
  cseLabTestSearch.SetBounds(41, 0, ccrLabTestSelector.SourceList.Width-41,
    pnlLabTestSearch.ClientHeight);
end;

procedure TFrameReportParameters.cseLabTestSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
begin
  with cseLabTestSearch do
    SetParams(['',cseLabTestSearch.Text,'P','20','']);
end;

procedure TFrameReportParameters.pnlParams052ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteNode('/PARAMS/LABTESTS');
end;

procedure TFrameReportParameters.pnlParams052GetValues(const aReportCode: String; aList: TCustomReportParameters;
   aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/LABTESTS');
      if rbLabTestsAll.Checked then
        begin
          SetAttrVal(group, 'ALL', True);
          DeleteChildren(group);
        end
      else
        with ccrLabTestSelector do
          begin
            SetAttrVal(group, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(group);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(group, 'LT', AsString[1]);
                      SetAttrVal(node, 'ID', AsString[0]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00215);
                aField := cseLabTestSearch;
              end;
          end;
    end;
end;

procedure TFrameReportParameters.pnlParams052Setup(const aReportCode: String);
begin
  if aReportCode = '12' then  // Combined Rx and Lab report
    begin
      rbLabTestsAll.Visible      := False;
      rbLabTestsSelected.Visible := False;
      rbLabTestsSelected.Checked := True;
    end
  else
    begin
      rbLabTestsAll.Visible      := True;
      rbLabTestsSelected.Visible := True;
    end;
end;

procedure TFrameReportParameters.pnlParams052SetValues(const aReportCode: String; aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbLabTestsAll.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/LABTESTS');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        begin
          loadSelectorResult(ccrLabTestSelector, group, ['ID','*']);
          if ccrLabTestSelector.ResultList.Items.Count > 0 then
            rbLabTestsSelected.Checked := True;
        end;
      if aReportCode = '12' then  // Combined Rx and Lab report
        rbLabTestsSelected.Checked := True;
    end;
end;

///////////////////////////// Parameters Panel #053 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrLTRSelectorResultListCanEditCell(
  Sender: TObject; ARow, ACol: Integer; var CanEdit: Boolean);
begin
  with ccrLTRSelector.ResultList do
    if ARow >= FixedRows then
      CanEdit := not StrToBoolDef(GridCells[ltrPanel,RealRowIndex(ARow)], False);
end;

procedure TFrameReportParameters.ccrLTRSelectorResultListCustomCompare(
  Sender: TObject; str1, str2: String; var Res: Integer);
var
  val1, val2: Double;
  mode: Integer;
begin
  res := 0;
  if str1 <> str2 then
    begin
      mode := 0;
      try
        val1 := StrToFloat(str1);
        Inc(mode,1);
      except
        val1 := 0;
      end;
      try
        val2 := StrToFloat(str2);
        Inc(mode,2);
      except
        val2 := 0;
      end;
      case mode of
      1:    //--- Number ]] String
        res := -1;
      2:    //--- Number ]] String
        res := 1;
      3:    //--- Both numeric
        if val1 > val2 then
          res := 1
        else if val1 < val2 then
          res := -1;
      else  //--- Both strings
        res := AnsiCompareText(str1, str2);
      end;
    end;
end;

procedure TFrameReportParameters.ccrLTRSelectorResultListGetDisplText(
  Sender: TObject; ACol, ARow: Integer; var Value: String);
begin
  with ccrLTRSelector.ResultList do
    if (ARow >= FixedRows) and (ACol = ltrPanel) then
      if (Value <> '0') and (Value <> '') then
        Value := 'P'
      else
        Value := ' ';
end;

procedure TFrameReportParameters.ccrLTRSelectorSplitterMoved(
  Sender: TObject);
begin
  cseLTRSearch.SetBounds(41, 0, ccrLTRSelector.SourceList.Width-41,
    pnlLTRSearch.ClientHeight);
end;

procedure TFrameReportParameters.cseLTRSearchSearchStart(aSender: TObject;
  var aCommand: TCCRSearchCommand);
begin
  with cseLTRSearch do
    SetParams(['',cseLTRSearch.Text,'P','20','']);
end;

procedure TFrameReportParameters.pnlParams053ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteNode('/PARAMS/LABTESTS');
end;

procedure TFrameReportParameters.pnlParams053GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
  params: TReportParameters;
  val: String;
begin
  params := TReportParameters(aList);
  group := params.GetNode('/PARAMS/LABTESTS');
  if rbLTRMostRecent.Checked then
      params.SetAttrVal(group, 'MOST_RECENT', '1')
  else
      params.SetAttrVal(group, 'MOST_RECENT', '0');
  if rbLTRAll.Checked then
    begin
      params.SetAttrVal(group, 'ALL', True);
      params.DeleteChildren(group);
    end
  else
    with ccrLTRSelector do
      begin
        params.SetAttrVal(group, 'ALL', False);
        if ResultChanged or FullUpdate then
          begin
            params.DeleteChildren(group);
            n := ResultList.RowCount - 1;
            for i:=ResultList.FixedRows to n do
              begin
                node := params.AppendNode(group, 'LT', ResultList.AllCells[ltrName,i]);
                params.SetAttrVal(node, 'ID', ResultList.AllCells[ltrIEN,i]);
                val := ResultList.GridCells[ltrPanel,i];
                if StrToBoolDef(val, False) then
                  params.SetAttrVal(node, 'P', val);
                //--- Optional result range
                val := ResultList.AllCells[ltrLow,i];
                if val <> '' then
                  params.SetAttrVal(node, 'LOW', val);
                val := ResultList.AllCells[ltrHigh,i];
                if val <> '' then
                  params.SetAttrVal(node, 'HIGH', val);
              end;
            ResultChanged := False;
          end;
        if ResultList.RowCount <= ResultList.FixedRows then
          begin
            aMsgLst.Add(RSC00215);
            aField := cseLTRSearch;
          end;
      end;
end;

procedure TFrameReportParameters.pnlParams053Setup(const aReportCode: String);
begin
  if aReportCode = '12' then  // Combined Rx and Lab report
    begin
      rbLTRAll.Visible      := True;
      rbLTRSelected.Visible := True;
      rbLTRSelected.Checked := True;
      rbLTRMostRecentAll.Visible := True;
      rbLTRMostRecentAll.Checked := True;
      rbLTRMostRecent.Visible := True;
    end
  else
    begin
      rbLTRAll.Visible      := False;
      rbLTRSelected.Visible := False;
      rbLTRMostRecentAll.Visible := False;
      rbLTRMostRecentAll.Checked := True;
      rbLTRMostRecent.Visible := False;
    end;
end;

procedure TFrameReportParameters.pnlParams053SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbLTRAll.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/LABTESTS');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        with ccrLTRSelector do
          begin
            loadSelectorGridResult(ccrLTRSelector, group, ['*', 'P', 'LOW','HIGH','ID']);
            if ResultList.RowCount > ResultList.FixedRows then
              rbLTRSelected.Checked := True;
          end;
      if aReportCode = '12' then  // Combined Rx and Lab report
        rbLTRSelected.Checked := True;
      if Assigned(group) and GetAttrBool(group, 'MOST_RECENT') then
        rbLTRMostRecent.Checked := True
      else
        rbLTRMostRecentAll.Checked := True;
    end;
end;

procedure TFrameReportParameters.pnlParams053ConstrainedResize(
  Sender: TObject; var MinWidth, MinHeight, MaxWidth, MaxHeight: Integer);
begin
  rbLTRMostRecentAll.Left := ccrLTRSelector.ResultList.Left - 3;
  rbLTRMostRecent.Left := rbLTRMostRecentAll.Left + 87;
end;

///////////////////////////// Parameters Panel #054 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.acDrugGroupAddExecute(Sender: TObject);
var
  gn: PVirtualNode;
begin
  with ccrDrugSelector.ResultTree do
    begin
      if edDrugGroupName.Text = '' then
        MessageDlg(RSC00224, mtWarning, [mbOK], 0)
      else if FindGroup(edDrugGroupName.Text) = nil then
        begin
          gn := AddGroup(edDrugGroupName.Text);
          if Assigned(gn) then
            begin
              FocusedNode := gn;
              ClearSelection;
              Selected[gn] := True;
            end;
        end
      else
        MessageDlg(Format(RSC00222,[edDrugGroupName.Text]), mtWarning, [mbOK], 0);
    end;
end;

procedure TFrameReportParameters.acDrugGroupDeleteExecute(Sender: TObject);
var
  next, node: PVirtualNode;
  rc: Word;
begin
  with ccrDrugSelector.ResultTree do
    begin
      rc := mrNo;
      next := GetFirstChild(RootNode);
      while Assigned(next) do
        begin
          node := next;
          next := GetNextSibling(node);
          if Selected[node] then
            begin
              if rc <> mrYesToAll then
                begin
                  rc := MessageDialog(rscReportParameters,
                          Format(RSC00223,[AsString[node,idscName]]),
                          mtConfirmation, [mbYes,mbNo,mbYesToAll,mbCancel], mrNo, 0);
                  if rc = mrCancel then
                    Break;
                end;
              if (rc = mrYesToAll) or (rc = mrYes) then
                DeleteGroup(node);
            end;
        end;
    end;
end;

procedure TFrameReportParameters.ccrDrugSelectorResultListKeyAction(
  Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
  var DoDefault: Boolean);
begin
  if (Shift = []) and (CharCode = VK_DELETE) then
    begin
      acDrugGroupDelete.Execute;
      DoDefault := False;
    end;
end;

procedure TFrameReportParameters.ccrDrugSelectorSplitterMoved(
  Sender: TObject);
begin
  pnlDrugSearch054.DisableAlign;
  try
    with cmbxDrugSearch054 do
      cseDrugSearch.SetBounds(Width, 17, ccrDrugSelector.SourceList.Width - Width, Height);
    pnlDrugGroup.Width  := ccrDrugSelector.ResultTree.Width;
    lblSearch054.Left := cseDrugSearch.Left;
    lblGroupName054.Left := pnlDrugSearch054.Width - pnlDrugGroup.Width;
  finally
    pnlDrugSearch054.EnableAlign;
  end;
end;

procedure TFrameReportParameters.cmbxDrugSearch054Select(Sender: TObject);
begin
  with ccrDrugSelector do
    begin
      case cmbxDrugSearch054.ItemIndex of
        0:    // Individual Formulations
          begin
            SourceType := idstFormulation;
            SourceList.Fields[idscCode].Visible := False;
          end;
        1:    // Generic Names
          begin
            SourceType := idstGeneric;
            SourceList.Fields[idscCode].Visible := False;
          end;
        4:    // Registry Medications
          begin
            SourceType := idstGeneric;
            SourceList.Fields[idscCode].Visible := False;
          end;
        5:    // Investigational Drugs
          begin
            SourceType := idstGeneric;
            SourceList.Fields[idscCode].Visible := False;
          end;
        else  // Drug Classes
          begin
            SourceType := idstDrugClass;
            SourceList.Fields[idscCode].Visible := True;
          end;
      end;
      SourceList.Clear;
    end;
end;

procedure TFrameReportParameters.cseDrugSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
begin
  with cseDrugSearch do
    case cmbxDrugSearch054.ItemIndex of
      0:  // Individual Formulations
        begin
          SearchFields := '1,2';
          SearchRPCName := rpcListDrugs;
          SetParams([cseDrugSearch.Text,'','','']);
        end;
      1:  // Generic Names
        begin
          SearchFields := '1,2';
          SearchRPCName := rpcListDrugs;
          SetParams([cseDrugSearch.Text,'G','','']);
        end;
      2:  // VA Drug Class Codes
        begin
          SearchFields := '1,2,3';
          SearchRPCName := rpcListVADrugClasses;
          SetParams(['',cseDrugSearch.Text,'','','']);
        end;
      3:  // VA Drug Class Names
        begin
          SearchFields := '1,2,3';
          SearchRPCName := rpcListVADrugClasses;
          SetParams(['',cseDrugSearch.Text,'N','','']);
        end;
      4:  // Registry Medications
        begin
          SearchFields := '1,2';
          SearchRPCName := rpcListRegistryDrugs;
          SetParams([cseDrugSearch.Text,RegInfo.IEN,'','']);
        end;
      5:  // Investigational Drugs
        begin
          SearchFields := '1,2';
          SearchRPCName := rpcListInvestigDrugs;
          SetParams([cseDrugSearch.Text,RegInfo.IEN,'','']);
        end;
    end;
end;

procedure TFrameReportParameters.edDrugGroupNameKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = []) and (Key = VK_RETURN) then
    acDrugGroupAdd.Execute;
end;

procedure TFrameReportParameters.pnlDrugGroupResize(Sender: TObject);
begin
  with pnlDrugGroup do
    begin
      edDrugGroupName.SetBounds(0, 0, ClientWidth - 2*ClientHeight, ClientHeight);
      spbDrugGroupAdd.SetBounds(edDrugGroupName.Width, 0, ClientHeight, ClientHeight);
      spbDrugGroupDelete.SetBounds(edDrugGroupName.Width+ClientHeight, 0,
        ClientHeight, ClientHeight);
    end;
end;

procedure TFrameReportParameters.pnlParams054ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  TReportParameters(aList).DeleteChildren(NodeDrugs);
end;

procedure TFrameReportParameters.pnlParams054GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);

  function section(srcSection: PVirtualNode; dstGroup: TDomNode): TDomNode;
  var
    srcItem: PVirtualNode;
    dstItem: TDomNode;
    empty: Boolean;
    sectionType: Integer;
    itemName: String;
    params:                           TReportParameters;
  begin
    params := TReportParameters(aList);
    with ccrDrugSelector.ResultTree do
      begin
        empty := True;
        sectionType := AsInteger[srcSection,idscType];
        case sectionType of
          idstDrugClass:
            Result := params.AppendNode(dstGroup, 'VARXCLS');
          idstFormulation:
            Result := params.AppendNode(dstGroup, 'FORMULATIONS');
          idstGeneric:
            Result := params.AppendNode(dstGroup, 'GENERIC');
          else
            Result := nil;
        end;

        if Assigned(Result) then
          begin
            srcItem := GetFirstChild(srcSection);
            while Assigned(srcItem) do
              begin
                itemName := AsString[srcItem,idscName];
                if sectionType = idstDrugClass then
                  begin
                    dstItem := params.AppendNode(Result, 'VARXCL', itemName);
                    params.SetAttrVal(dstItem, 'CODE', AsString[srcItem,idscCode]);
                  end
                else
                  dstItem := params.AppendNode(Result, 'DRUG', itemName);
               params.SetAttrVal(dstItem, 'ID', AsString[srcItem,idscIEN]);
               empty := False;
                srcItem := GetNextSibling(srcItem);
              end;

            if empty then
              begin
                params.DeleteNode(Result);
                Result := nil;
              end;
          end;
      end;
  end;

  function group(srcGroup: PVirtualNode; dstNode: TDomNode): TDomNode;
  var
    srcSection: PVirtualNode;
    empty: Boolean;
    params: TReportParameters;
  begin
    params := TReportParameters(aList);
    with ccrDrugSelector.ResultTree do
      begin
        empty := True;
        Result := params.AppendNode(dstNode, 'GROUP');
        params.SetAttrVal(Result, 'ID', AsString[srcGroup,idscName]);

        srcSection := GetFirstChild(srcGroup);
        while Assigned(srcSection) do
          begin
            if section(srcSection, Result) <> nil then
              empty := False;
            srcSection := GetNextSibling(srcSection);
          end;

        if empty then
          begin
            params.DeleteNode(Result);
            Result := nil;
          end;
      end;
  end;

var
  srcGroup: PVirtualNode;
  empty: Boolean;
  params: TReportParameters;
begin
  params := TReportParameters(aList);
  with ccrDrugSelector do
    begin
      if rbDrugsAll.Checked then
        begin
          params.SetAttrVal(NodeDrugs, 'ALL', True);
          params.DeleteChildren(NodeDrugs);
        end
      else
        begin
          empty := True;
          params.SetAttrVal(NodeDrugs, 'ALL', False);
          if ResultChanged or FullUpdate then
            begin
              params.DeleteChildren(NodeDrugs);
              srcGroup := ResultTree.GetFirstChild(nil);
              while Assigned(srcGroup) do
                begin
                  if group(srcGroup, NodeDrugs) <> nil then
                    empty := False;
                  srcGroup := ResultTree.GetNextSibling(srcGroup);
                end;

              ResultChanged := False;
            end;
          if empty then
            begin
              aMsgLst.Add(RSC00209);
              aField := cseDrugSearch;
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams054Setup(const aReportCode: String);
begin
  acDrugGroupAdd.Enabled    := True;
  acDrugGroupDelete.Enabled := True;
  pnlDrugGroup.Visible      := True;
  lblSearch054.Left := cseDrugSearch.Left;
  lblGroupName054.Left := pnlDrugSearch054.Width - pnlDrugGroup.Width;
end;

procedure TFrameReportParameters.pnlParams054SetValues(const aReportCode: String;
  aList: TCustomReportParameters);

  function section(srcSection: TDomNode; dstGroup: PVirtualNode): PVirtualNode;
  var
    srcItem: TDomNode;
    aName: String;
    dstItem: PVirtualNode;
    empty: Boolean;
    params: TReportParameters;
    sectionType: Integer;
  begin
    params := TReportParameters(aList);
    empty := True;
    sectionType := 0;
    Result := nil;
    with ccrDrugSelector.ResultTree do
      begin
        aName := srcSection.NodeName;
        if aName = 'FORMULATIONS' then
          sectionType := idstFormulation
        else if aName = 'GENERIC' then
          sectionType := idstGeneric
        else if aName = 'VARXCLS' then
          sectionType := idstDrugClass;

        if sectionType > 0 then
          Result := GetSection(dstGroup, sectionType);

        if Assigned(Result) then
          begin
            srcItem := srcSection.FirstChild;
            while Assigned(srcItem) do
              begin
                aName := params.GetNodeVal(srcItem);
                if aName <> '' then
                  begin
                    dstItem := AddItem(Result, aName);
                    AsString[dstItem,idscIEN] := params.GetAttrStr(srcItem, 'ID');
                    if sectionType = idstDrugClass then
                      AsString[dstItem,idscCode] := params.GetAttrStr(srcItem, 'CODE');
                    empty := False;
                  end;
                srcItem := srcItem.NextSibling;
              end;
            if empty then
              Result := nil;
          end;
      end;
  end;

  function group(srcGroup: TDomNode): PVirtualNode;
  var
    srcSection: TDomNode;
    params: TReportParameters;
    empty: Boolean;
    grpName: String;
  begin
    params := TReportParameters(aList);
    empty := True;
    with ccrDrugSelector.ResultTree do
      begin
        grpName := params.GetAttrStr(srcGroup, 'ID');
        if grpName <> '' then
          begin
            Result := FindGroup(grpName);
            if not Assigned(Result) then
              Result := AddGroup(grpName);
          end
        else
          Result := nil;
        if Assigned(Result) then
          begin
            //--- Regular sections
            srcSection := srcGroup.FirstChild;
            while Assigned(srcSection) do
              begin
                if section(srcSection, Result) <> nil then
                  empty := False;
                srcSection := srcSection.NextSibling;
              end;
          end;
      if empty then
        begin
          DeleteGroup(Result);
          Result := nil;
        end;
      end;
  end;

var
  srcGroup: TDomNode;
  params: TReportParameters;
  empty: Boolean;
begin
  params := TReportParameters(aList);
  with ccrDrugSelector do
    begin
      ResultTree.BeginUpdate;
      try
        rbDrugsAll.Checked := True; // This also clears the selector
        if Assigned(NodeDrugs) and not params.GetAttrBool(NodeDrugs, 'ALL') then
          begin
            empty := True;
            srcGroup := NodeDrugs.FirstChild;
            while Assigned(srcGroup) do
              begin
                if group(srcGroup) <> nil then
                  empty := False;
                srcGroup := srcGroup.NextSibling;
              end;
            if not empty then
              rbDrugsSelected.Checked := True
            else
              Clear;
          end;
      finally
        ResultTree.EndUpdate;
      end;

      ResultChanged := False;
    end;
end;

procedure TFrameReportParameters.ccrDrugSelectorAdd(Sender: TObject);
begin
  if ccrDrugSelector.ResultTree.GetFirstChild(ccrDrugSelector.ResultTree.RootNode) = nil then
    MessageDlg(RSC00226, mtWarning, [mbOK], 0)
  else
    inherited;
end;

procedure TFrameReportParameters.ccrDrugSelectorAddAll(Sender: TObject);
begin
  if ccrDrugSelector.ResultTree.GetFirstChild(ccrDrugSelector.ResultTree.RootNode) = nil then
    MessageDlg(RSC00226, mtWarning, [mbOK], 0)
  else
    inherited;
end;

procedure TFrameReportParameters.rbDrugsAllClick(Sender: TObject);
begin
  rbAllClick(Sender);
  btnAllRegistryMeds.Enabled := false;
end;

procedure TFrameReportParameters.rbDrugsSelectedClick(Sender: TObject);
begin
  rbSelectedClick(Sender);
  btnAllRegistryMeds.Enabled := true;
end;

procedure TFrameReportParameters.btnAllRegistryMedsClick(Sender: TObject);
begin
  cmbxDrugSearch054.ItemIndex := 4;   //Registry medications
  cmbxDrugSearch054Select(Sender);
  cseDrugSearch.Text := '??';
  cseDrugSearch.Search;
end;

///////////////////////////// Parameters Panel #056 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams056GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    SetAttrVal(NodeDrugs, 'INVESTIG', cbInvestigDrugs056.Checked);
end;

procedure TFrameReportParameters.pnlParams056SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    cbInvestigDrugs056.Checked := GetAttrBool(NodeDrugs, 'INVESTIG');
end;

///////////////////////////// Parameters Panel #058 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrICD9SelectorSplitterMoved(
  Sender: TObject);
begin
  with cmbbICD9Search do
    cseICD9Search.SetBounds(Width, 0,
      ccrICD9Selector.SourceList.Width - Width, Height);
end;

procedure TFrameReportParameters.cseICD9SearchSearchStart(aSender: TObject;
  var aCommand: TCCRSearchCommand);
var
  flags: String;
begin
  if cmbbICD9Search.ItemIndex = 1 then
    flags := 'D'
  else
    flags := '';
  with cseICD9Search do
    SetParams(['',Text,flags,'20','']);
end;

procedure TFrameReportParameters.pnlParams058GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/ICD9LST');
      if rbICD9All.Checked then
        begin
          SetAttrVal(group, 'ALL', True);
          DeleteChildren(group);
        end
      else
        with ccrICD9Selector do
          begin
            SetAttrVal(group, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(group);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(group, 'ICD9', AsString[1]);
                      SetAttrVal(node, 'ID',  AsString[0]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00216);
                aField := cseICD9Search;
              end;
          end;
    end;
end;

procedure TFrameReportParameters.pnlParams058SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbICD9All.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/ICD9LST');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        begin
          loadSelectorResult(ccrICD9Selector, group, ['ID','*']);
          if ccrICD9Selector.ResultList.Items.Count > 0 then
            rbICD9Selected.Checked := True;
        end;
    end;
end;

///////////////////////////// Parameters Panel #059 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrCPTSelectorSplitterMoved(
  Sender: TObject);
begin
  with cmbbCPTSearch do
    cseCPTSearch.SetBounds(Width, 0,
      ccrCPTSelector.SourceList.Width - Width, Height);
end;

procedure TFrameReportParameters.cseCPTSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
var
  flags: String;
begin
  if cmbbCPTSearch.ItemIndex = 1 then
    flags := 'D'
  else
    flags := '';
  with cseCPTSearch do
    SetParams(['',Text,flags,'20','']);
end;

procedure TFrameReportParameters.pnlParams059GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  group, node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/CPTLST');
      if rbCPTAll.Checked then
        begin
          SetAttrVal(group, 'ALL', True);
          DeleteChildren(group);
        end
      else
        with ccrCPTSelector do
          begin
            SetAttrVal(group, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(group);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(group, 'CPT', AsString[1]);
                      SetAttrVal(node, 'ID',  AsString[0]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00220);
                aField := cseCPTSearch;
              end;
          end;
    end;
end;

procedure TFrameReportParameters.pnlParams059SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  group: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      rbCPTAll.Checked := True; // This also clears the selector
      group := FindNode('/PARAMS/CPTLST');
      if Assigned(group) and not GetAttrBool(group, 'ALL') then
        begin
          loadSelectorResult(ccrCPTSelector, group, ['ID','*']);
          if ccrCPTSelector.ResultList.Items.Count > 0 then
            rbCPTSelected.Checked := True;
        end;
    end;
end;

///////////////////////////// Parameters Panel #060 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams060GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodePatients, 'NOTSEEN',  cbNotSeen.Checked);
      SetAttrVal(NodePatients, 'SEEN',     cbSeen.Checked);
    end;
  if not (cbSeen.Checked or cbNotSeen.Checked) then
    begin
      aMsgLst.Add(RSC00217);
      aField := cbSeen;
    end;
end;

procedure TFrameReportParameters.pnlParams060SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbNotSeen.Checked  := GetAttrBool(NodePatients, 'NOTSEEN');
      cbSeen.Checked     := GetAttrBool(NodePatients, 'SEEN');
    end;
end;

///////////////////////////// Parameters Panel #062 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams062GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodeOptions, 'COMPLETE', rbComplete.Checked);
      SetAttrVal(NodeOptions, 'SUMMARY',  rbSummary.Checked);
    end;
  if not (rbComplete.Checked or rbSummary.Checked) then
    begin
      aMsgLst.Add(RSC00221);
      aField := rbComplete;
    end;
end;

procedure TFrameReportParameters.pnlParams062SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      rbComplete.Checked := GetAttrBool(NodeOptions, 'COMPLETE');
      rbSummary.Checked  := GetAttrBool(NodeOptions, 'SUMMARY');
    end;
end;

///////////////////////////// Parameters Panel #064 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.cbgLabChange(Sender: TObject);
begin
  if StrToIntDef(cbgLab.Code, 0) <> 0 then
    begin
      pnlParams011.Enabled := True;
      pnlParams052.Enabled := True;
      pnlParams053.Enabled := True;
    end
  else
    begin
      pnlParams011.Enabled := False;
      pnlParams052.Enabled := False;
      pnlParams053.Enabled := False;
    end;
end;

procedure TFrameReportParameters.cbgPharmacyChange(Sender: TObject);
begin
  if StrToIntDef(cbgPharmacy.Code, 0) <> 0 then
    begin
      pnlParams010.Enabled := True;
      pnlParams044.Enabled := True;
      pnlParams054.Enabled := True;
    end
  else
    begin
      pnlParams010.Enabled := False;
      pnlParams044.Enabled := False;
      pnlParams054.Enabled := False;
    end;
end;

procedure TFrameReportParameters.pnlParams064GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  icLab, icPharm: Integer;
begin
  with NodePatients do
    begin
      removeAttribute('LAB');
      removeAttribute('NOLAB');
      removeAttribute('NOPHARM');
      removeAttribute('PHARM');
    end;

  icLab   := StrToIntDef(cbgLab.Code, 0);
  icPharm := StrToIntDef(cbgPharmacy.Code, 0);

  with TReportParameters(aList) do
    begin
      if icLab > 0 then
        SetAttrVal(NodePatients, 'LAB', '1')
      else if icLab < 0 then
        SetAttrVal(NodePatients, 'NOLAB', '1');
      if icPharm > 0 then
        SetAttrVal(NodePatients, 'PHARM', '1')
      else if icPharm < 0 then
        SetAttrVal(NodePatients, 'NOPHARM', '1');
    end;
  if (icLab = 0) and (icPharm = 0) then
    begin
      aMsgLst.Add(RSC00213);
      aField := cbgPharmacy.CheckBoxes[0].Control;
    end;
end;

procedure TFrameReportParameters.pnlParams064SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      if GetAttrBool(NodePatients, 'LAB') then
        cbgLab.Code := '1'
      else if GetAttrBool(NodePatients, 'NOLAB') then
        cbgLab.Code := '-1'
      else
        cbgLab.Code := '0';
      if GetAttrBool(NodePatients, 'PHARM') then
        cbgPharmacy.Code := '1'
      else if GetAttrBool(NodePatients, 'NOPHARM') then
        cbgPharmacy.Code := '-1'
      else
        cbgPharmacy.Code := '0';
    end;
end;

///////////////////////////// Parameters Panel #065 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams065GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with NodePatients do
    begin
      removeAttribute('PROC');
      removeAttribute('NOPROC');
    end;

  with TReportParameters(aList) do
    if rbRcvdProcedures.Checked then
      SetAttrVal(NodePatients, 'PROC', '1')
    else
      SetAttrVal(NodePatients, 'NOPROC', '1');
end;

procedure TFrameReportParameters.pnlParams065SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    if GetAttrBool(NodePatients, 'NOPROC') then
      rbDidNotRcvdProcedures.Checked := True
    else
      rbRcvdProcedures.Checked := True;
end;

///////////////////////////// Parameters Panel #066 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.cbCareOnlyClick(Sender: TObject);
begin
  pnlParams012.Enabled := cbCareOnly.Checked;
end;

procedure TFrameReportParameters.pnlParams066GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    SetAttrVal(NodePatients, 'CAREONLY', cbCareOnly.Checked);
end;

procedure TFrameReportParameters.pnlParams066SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    cbCareOnly.Checked := GetAttrBool(NodePatients, 'CAREONLY');
  pnlParams012.Enabled := cbCareOnly.Checked;
end;

///////////////////////////// Parameters Panel #070 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.agRegistriesCellChanging(Sender: TObject;
  OldRow, OldCol, NewRow, NewCol: Integer; var Allow: Boolean);
begin
  Allow := (NewRow < agRegistries.FixedRows) or (NewCol = 0);
end;

procedure TFrameReportParameters.pnlParams070GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, rri: Integer;
  group, node: TDomNode;
  modeVal: String;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/OTHER_REGISTRIES');
      DeleteChildren(group);
      for i:=agRegistries.RowCount-1 downto agRegistries.FixedRows do
        begin
          rri := agRegistries.RealRowIndex(i);
          modeVal := Trim(agRegistries.GridCells[orMode,rri]);
          if modeVal <> '' then
            begin
              node := AppendNode(group, 'REGISTRY', agRegistries.GridCells[orDescr,rri]);
              SetAttrVal(node, 'ID', agRegistries.GridCells[orIEN,rri]);
              if modeVal = 'Include' then
                SetAttrVal(node, 'MODE', '1')
              else
                SetAttrVal(node, 'MODE', '-1');
              SetAttrVal(node, 'NAME', agRegistries.GridCells[orName,rri]);
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams070SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  i, rri: Integer;
  group, node: TDomNode;
  query: String;
begin
  if agRegistries.RowCount > agRegistries.FixedRows then
    with TReportParameters(aList) do
      begin
        group := FindNode('/PARAMS/OTHER_REGISTRIES');
        if Assigned(group) then
          for i:=agRegistries.RowCount-1 downto agRegistries.FixedRows do
            begin
              rri := agLocalFields.RealRowIndex(i);
              query := 'REGISTRY[@ID=' + agRegistries.GridCells[orIEN,rri] + ']';
              node := group.FindNode(query);
              if Assigned(node) then
                case TReportParameters(aList).GetAttrInt(node, 'MODE') of
                  -1:  agRegistries.GridCells[orMode,rri] := 'Exclude';
                   1:  agRegistries.GridCells[orMode,rri] := 'Include';
                  else agRegistries.GridCells[orMode,rri] := ' ';
                end
              else
                agRegistries.GridCells[orMode,rri] := ' ';
            end
        else
          for i:=agRegistries.RowCount-1 downto agRegistries.FixedRows do
            begin
              rri := agRegistries.RealRowIndex(i);
              agRegistries.GridCells[orMode,rri] := ' ';
            end;
      end
  else
    begin
      pnlParams070.Align   := alBottom;
      pnlParams070.Visible := False;
    end;
end;

///////////////////////////// Parameters Panel #100 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.agLocalFieldsCellChanging(Sender: TObject;
  OldRow, OldCol, NewRow, NewCol: Integer; var Allow: Boolean);
begin
  Allow := (NewRow < agLocalFields.FixedRows) or (NewCol = 0);
end;

procedure TFrameReportParameters.pnlParams100GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, rri: Integer;
  group, node: TDomNode;
  modeVal: String;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/LOCAL_FIELDS');
      DeleteChildren(group);
      for i:=agLocalFields.RowCount-1 downto agLocalFields.FixedRows do
        begin
          rri := agLocalFields.RealRowIndex(i);
          modeVal := Trim(agLocalFields.GridCells[lfMode,rri]);
          if modeVal <> '' then
            begin
              node := AppendNode(group, 'FIELD', agLocalFields.GridCells[lfDescr,rri]);
              SetAttrVal(node, 'ID', agLocalFields.GridCells[lfIEN,rri]);
              if modeVal = 'Include' then
                SetAttrVal(node, 'MODE', '1')
              else
                SetAttrVal(node, 'MODE', '-1');
              SetAttrVal(node, 'NAME', agLocalFields.GridCells[lfName,rri]);
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams100SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  i, rri: Integer;
  group, node: TDomNode;
  query: String;
begin
  if agLocalFields.RowCount > agLocalFields.FixedRows then
    with TReportParameters(aList) do
      begin
        group := FindNode('/PARAMS/LOCAL_FIELDS');
        if Assigned(group) then
          for i:=agLocalFields.RowCount-1 downto agLocalFields.FixedRows do
            begin
              rri := agLocalFields.RealRowIndex(i);
              query := 'FIELD[@ID=' + agLocalFields.GridCells[lfIEN,rri] + ']';
              node := group.FindNode(query);
              if Assigned(node) then
                case TReportParameters(aList).GetAttrInt(node, 'MODE') of
                  -1:  agLocalFields.GridCells[lfMode,rri] := 'Exclude';
                   1:  agLocalFields.GridCells[lfMode,rri] := 'Include';
                  else agLocalFields.GridCells[lfMode,rri] := ' ';
                end
              else
                agLocalFields.GridCells[lfMode,rri] := ' ';
            end
        else
          for i:=agLocalFields.RowCount-1 downto agLocalFields.FixedRows do
            begin
              rri := agLocalFields.RealRowIndex(i);
              agLocalFields.GridCells[lfMode,rri] := ' ';
            end;
      end
  else
    begin
      pnlParams100.Align   := alBottom;
      pnlParams100.Visible := False;
    end;
end;

///////////////////////////// Parameters Panel #120 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams120GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    if rbDetailsBoth.Checked then
      begin
        SetNodeVal('/PARAMS/MAXUTNUM', edHighestUtilNum120.Text);
        SetNodeVal('/PARAMS/MINRPNUM', edMinRPNum120.Text);
        if (edHighestUtilNum120.Text = '') and (edMinRPNum120.Text = '') then
          begin
            aMsgLst.Add(RSC00218);
            aField := edHighestUtilNum120;
          end;
      end
    else
      begin
        DeleteNode('/PARAMS/MAXUTNUM');
        DeleteNode('/PARAMS/MINRPNUM');
      end;
end;

procedure TFrameReportParameters.pnlParams120SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      edHighestUtilNum120.Text := GetNodeVal('/PARAMS/MAXUTNUM');
      edMinRPNum120.Text       := GetNodeVal('/PARAMS/MINRPNUM');
      if (edHighestUtilNum120.Text <> '') or (edMinRPNum120.Text <> '') then
        rbDetailsBoth.Checked := True
      else
        rbSummaryBoth.Checked := True;
    end;
end;

procedure TFrameReportParameters.rbDetailsBothClick(Sender: TObject);
begin
  edHighestUtilNum120.Enabled := True;
  edMinRPNum120.Enabled       := True;
end;

procedure TFrameReportParameters.rbSummaryBothClick(Sender: TObject);
begin
  with edHighestUtilNum120 do
    begin
      Enabled := False;
      Text    := '';
    end;
  with edMinRPNum120 do
    begin
      Enabled := False;
      Text    := '';
    end;
end;

///////////////////////////// Parameters Panel #130 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams130GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i: Integer;
  group, node: TDomNode;
  ci: TCCRGridItem;
begin
  with TReportParameters(aList) do
    begin
      group := GetNode('/PARAMS/SELRULES');
      DeleteChildren(group);
      for i:=cgvSelectionRules.Items.Count-1 downto 0 do
        begin
          ci := cgvSelectionRules.Items[i];
          if ci.Checked then
            begin
              node := AppendNode(group, 'RULE', ci.AsString[iDescr]);
              SetAttrVal(node, 'ID', ci.AsString[iIEN]);
              SetAttrVal(node, 'NAME', ci.AsString[iName]);
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams130SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
var
  i: Integer;
  group: TDomNode;
  query: String;
begin
  if cgvSelectionRules.Items.Count > 0 then
    with TReportParameters(aList) do
      begin
        group := FindNode('/PARAMS/SELRULES');
        if Assigned(group) then
          for i:=cgvSelectionRules.Items.Count-1 downto 0 do
            begin
              query := 'RULE[@ID=' + cgvSelectionRules.Items[i].AsString[iIEN] + ']';
              cgvSelectionRules.Items[i].Checked := Assigned(group.FindNode(query));
            end
        else
          for i:=cgvSelectionRules.Items.Count-1 downto 0 do
            cgvSelectionRules.Items[i].Checked := False;
      end
  else
    begin
      pnlParams130.Align   := alBottom;
      pnlParams130.Visible := False;
    end;
end;

///////////////////////////// Parameters Panel #140 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.ccrPatientSelectorSplitterMoved(
  Sender: TObject);
begin
  csePatientSearch.SetBounds(41, 0, ccrPatientSelector.SourceList.Width-41,
    pnlPatientSearch140.ClientHeight);
end;

procedure TFrameReportParameters.csePatientSearchSearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
begin
  with csePatientSearch do
    begin
      SetParams([RegInfo.IEN,'0',csePatientSearch.Text,'D','20','']);
      SearchMaxCount := CCROptions.MaxPatientCount;
    end;
end;

procedure TFrameReportParameters.pnlParams140GetValues(const aReportCode: String;
  aList: TCustomReportParameters; aMsgLst: TStrings; var aField: TWinControl);
var
  i, n: Integer;
  node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      if rbPatientsAll.Checked then
        begin
          SetAttrVal(NodePatients, 'ALL', True);
          DeleteChildren(NodePatients);
        end
      else
        with ccrPatientSelector do
          begin
            SetAttrVal(NodePatients, 'ALL', False);
            if ResultChanged or FullUpdate then
              begin
                DeleteChildren(NodePatients);
                n := ResultList.Items.Count - 1;
                for i:=0 to n do
                  with ResultList.Items[i] do
                    begin
                      node := AppendNode(NodePatients, 'PT', AsString[1]);
                      SetAttrVal(node, 'ID', AsString[0]);
                      SetAttrVal(node, 'SSN', AsString[2]);
                    end;
                ResultChanged := False;
              end;
            if ResultList.Items.Count < 1 then
              begin
                aMsgLst.Add(RSC00219);
                aField := csePatientSearch;
              end;
          end;
    end
end;

procedure TFrameReportParameters.pnlParams140SetValues(const aReportCode: String;
  aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      rbpatientsAll.Checked := True; // This also clears the selector
      if not GetAttrBool(NodePatients, 'ALL') then
        begin
          loadSelectorResult(ccrPatientSelector, NodePatients, ['ID','*','SSN','ID']);
          if ccrPatientSelector.ResultList.Items.Count > 0 then
            rbPatientsSelected.Checked := True;
        end;
    end;
end;

procedure TFrameReportParameters.rbPatientsAllClick(Sender: TObject);
begin
  rbAllClick(rbPatientsAll);
  pnlParams070.Enabled := True;
  pnlParams100.Enabled := True;
end;

procedure TFrameReportParameters.rbPatientsSelectedClick(Sender: TObject);
begin
  rbSelectedClick(rbPatientsSelected);
  pnlParams070.Enabled := False;
  pnlParams100.Enabled := False;
end;

///////////////////////////// Parameters Panel #150 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.cbInpatient150Click(Sender: TObject);
begin
  pnlParams160.Enabled := cbInpatient150.Checked;
end;

procedure TFrameReportParameters.cbOutpatient150Click(Sender: TObject);
begin
  pnlParams059.Enabled := cbOutpatient150.Checked;
end;

procedure TFrameReportParameters.pnlParams150GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);
begin
  with TReportParameters(aList) do
    begin
      SetAttrVal(NodePatients, 'INPATIENT',  cbInpatient150.Checked);
      SetAttrVal(NodePatients, 'OUTPATIENT', cbOutpatient150.Checked);
    end;
  if not (cbInpatient150.Checked or cbOutpatient150.Checked) then
    begin
      aMsgLst.Add(RSC00206);
      aField := cbInpatient150;
    end;
end;

procedure TFrameReportParameters.pnlParams150SetValues(
  const aReportCode: String; aList: TCustomReportParameters);
begin
  with TReportParameters(aList) do
    begin
      cbInpatient150.Checked  := GetAttrBool(NodePatients, 'INPATIENT');
      cbOutpatient150.Checked := GetAttrBool(NodePatients, 'OUTPATIENT');
    end;
  pnlParams160.Enabled := cbInpatient150.Checked;
  pnlParams059.Enabled := cbOutpatient150.Checked;
end;

///////////////////////////// Parameters Panel #160 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.acICD9GroupAddExecute(Sender: TObject);
var
  gn: PVirtualNode;
begin
  with ccrICD9Selector160.ResultTree do
    begin
      if edICD9GroupName.Text = '' then
        MessageDlg(RSC00224, mtWarning, [mbOK], 0)
      else if FindGroup(edICD9GroupName.Text) = nil then
        begin
          gn := AddGroup(edICD9GroupName.Text);
          if Assigned(gn) then
            begin
              FocusedNode := gn;
              ClearSelection;
              Selected[gn] := True;
            end;
        end
      else
        MessageDlg(Format(RSC00222,[edICD9GroupName.Text]), mtWarning, [mbOK], 0);
    end;
end;

procedure TFrameReportParameters.acICD9GroupDeleteExecute(Sender: TObject);
begin
  deleteResultTreeGroup(ccrICD9Selector160.ResultTree);
end;

procedure TFrameReportParameters.ccrICD9Selector160ResultListKeyAction(
  Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
  var DoDefault: Boolean);
begin
  if (Shift = []) and (CharCode = VK_DELETE) then
    begin
      deleteResultTreeGroup(ccrICD9Selector160.ResultTree);
      DoDefault := False;
    end;
end;

procedure TFrameReportParameters.cseICD9Search160SearchStart(
  aSender: TObject; var aCommand: TCCRSearchCommand);
var
  flags: String;
begin
  if cmbxICD9Search160.ItemIndex = 1 then
    flags := 'D'
  else
    flags := '';
  if ccrICD9Selector160.ProcMode then
    flags := flags + 'O';
  with cseICD9Search160 do
    SetParams(['',Text,flags,'20','']);
end;

procedure TFrameReportParameters.edICD9GroupNameKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = []) and (Key = VK_RETURN) then
    acICD9GroupAdd.Execute;
end;

procedure TFrameReportParameters.pnlParams160ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
var
  node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      node := FindNode('/PARAMS/ICD9LST');
      if Assigned(node) then
        DeleteChildren(node);
    end;
end;

procedure TFrameReportParameters.pnlParams160GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);

  function group(srcGroup: PVirtualNode; dstNode: TDomNode): TDomNode;
  var
    srcItem: PVirtualNode;
    empty: Boolean;
    params: TReportParameters;
    dstItem: TDomNode;
    itemName: String;
  begin
    params := TReportParameters(aList);
    with ccrICD9Selector160.ResultTree do
      begin
        empty := True;
        Result := params.AppendNode(dstNode, 'GROUP');
        params.SetAttrVal(Result, 'ID', AsString[srcGroup,idscName]);

        srcItem := GetFirstChild(srcGroup);
        while Assigned(srcItem) do
          begin
            itemName := AsString[srcItem,idscName];
            dstItem := params.AppendNode(Result, 'ICD9', itemName);
            params.SetAttrVal(dstItem, 'ID', AsString[srcItem,idscCode]);
            empty := False;
            srcItem := GetNextSibling(srcItem);
          end;

        if empty then
          begin
            params.DeleteNode(Result);
            Result := nil;
          end;
      end;
  end;

var
  srcGroup: PVirtualNode;
  empty: Boolean;
  params: TReportParameters;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  node := params.GetNode('/PARAMS/ICD9LST');
  with ccrICD9Selector160 do
    begin
      params.SetAttrVal(node, 'PROCMODE', ProcMode);
      if rbAll160.Checked then
        begin
          params.SetAttrVal(node, 'ALL', True);
          params.DeleteChildren(node);
        end
      else
        begin
          empty := True;
          params.SetAttrVal(node, 'ALL', False);
          if ResultChanged or FullUpdate then
            begin
              params.DeleteChildren(node);
              srcGroup := ResultTree.GetFirstChild(nil);
              while Assigned(srcGroup) do
                begin
                  if group(srcGroup, node) <> nil then
                    empty := False;
                  srcGroup := ResultTree.GetNextSibling(srcGroup);
                end;
              ResultChanged := False;
            end;
          if empty then
            begin
              aMsgLst.Add(RSC00216);
              aField := cseICD9Search160;
            end;
        end;
    end;
end;

procedure TFrameReportParameters.pnlParams160Setup(
  const aReportCode: String);
begin
  with ccrICD9Selector160 do
    begin
      ProcMode := (aReportCode = '15');
      Clear;
    end;
  lblSearch160.Left := cseICD9Search160.Left;
  lblGroupName160.Left := pnlICD9Search160.Width - pnlICD9Group160.Width;
end;

procedure TFrameReportParameters.pnlParams160SetValues(
  const aReportCode: String; aList: TCustomReportParameters);

  function group(srcGroup: TDomNode): PVirtualNode;
  var
    srcItem: TDomNode;
    dstItem: PVirtualNode;
    params: TReportParameters;
    empty: Boolean;
    aName: String;
    dummy: String;
  begin
    params := TReportParameters(aList);
    with ccrICD9Selector160.ResultTree do
      begin
        // Leave the "dummy := params.Text" line in even though it does nothing.
        // When it is removed, an access violation frequently occurs on the line
        // where GetAttrStr is used.
        dummy := params.Text;
        aName := params.GetAttrStr(srcGroup, 'ID');
        if aName <> '' then
          begin
            Result := FindGroup(aName);
            if not Assigned(Result) then
              Result := AddGroup(aName);
          end
        else
          Result := nil;
        if Assigned(Result) then
          begin
            DeleteChildren(Result);
            empty := True;
            srcItem := srcGroup.FirstChild;
            while Assigned(srcItem) do
              begin
                aName := params.GetNodeVal(srcItem);
                if aName <> '' then
                  begin
                    dstItem := AddItem(Result, aName, params.GetAttrStr(srcItem,'ID'));
                    empty := False;
                  end;
                srcItem := srcItem.NextSibling;
              end;
            if empty then
              begin
                DeleteGroup(Result);
                Result := nil;
              end;
          end;
      end;
  end;

var
  srcGroup: TDomNode;
  params: TReportParameters;
  empty: Boolean;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  with ccrICD9Selector160 do
    begin
      ResultTree.BeginUpdate;
      try
        node := params.FindNode('/PARAMS/ICD9LST');
        if Assigned(node) and not params.GetAttrBool(node, 'ALL') then
          begin
            empty := True;
            srcGroup := node.FirstChild;
            while Assigned(srcGroup) do
              begin
                if group(srcGroup) <> nil then
                  empty := False;
                srcGroup := srcGroup.NextSibling;
              end;
            if not empty then
              rbSelected160.Checked := True
            else
              Clear;
          end
        else
          rbAll160.Checked := True; // This also clears the selector
      finally
        ResultTree.EndUpdate;
      end;
      ResultChanged := False;
    end;
end;

procedure TFrameReportParameters.pnlICD9Group160Resize(Sender: TObject);
begin
  with pnlICD9Group160 do
    begin
      edICD9GroupName.SetBounds(0, 0, ClientWidth - 2*ClientHeight, ClientHeight);
      spbICD9GroupAdd.SetBounds(edICD9GroupName.Width, 0, ClientHeight, ClientHeight);
      spbICD9GroupDelete.SetBounds(edICD9GroupName.Width+ClientHeight, 0,
        ClientHeight, ClientHeight);
    end;
end;

procedure TFrameReportParameters.ccrICD9Selector160SplitterMoved(
  Sender: TObject);
begin
  pnlICD9Search160.DisableAlign;
  try
    with cmbxICD9Search160 do
      cseICD9Search160.SetBounds(Width, 17, ccrICD9Selector160.SourceList.Width - Width, Height);
    pnlICD9Group160.Width  := ccrICD9Selector160.ResultTree.Width;
    lblSearch160.Left := cseICD9Search160.Left;
    lblGroupName160.Left := pnlICD9Search160.Width - pnlICD9Group160.Width;
  finally
    pnlICD9Search160.EnableAlign;
  end;
end;

///////////////////////////// Parameters Panel #180 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams180ClearParams(
  const aReportCode: String; aList: TCustomReportParameters);
var
  node: TDomNode;
begin
  with TReportParameters(aList) do
    begin
      node := FindNode('/PARAMS/ICD9FILT');
      if Assigned(node) then
        DeleteChildren(node);
    end;
end;

procedure TFrameReportParameters.pnlParams180GetValues(
  const aReportCode: String; aList: TCustomReportParameters;
  aMsgLst: TStrings; var aField: TWinControl);

  function group(srcGroup: PVirtualNode; dstNode: TDomNode): TDomNode;
  var
    srcItem: PVirtualNode;
    empty: Boolean;
    params: TReportParameters;
    dstItem: TDomNode;
    itemName: String;
  begin
    params := TReportParameters(aList);
    with ccrOtherDiagSelector180.ResultTree do
      begin
        empty := True;
        Result := params.AppendNode(dstNode, 'GROUP');
        params.SetAttrVal(Result, 'ID', AsString[srcGroup,idscName]);

        srcItem := GetFirstChild(srcGroup);
        while Assigned(srcItem) do
          begin
            itemName := AsString[srcItem,idscName];
            dstItem := params.AppendNode(Result, 'ICD9', itemName);
            params.SetAttrVal(dstItem, 'ID', AsString[srcItem,idscCode]);
            empty := False;
            srcItem := GetNextSibling(srcItem);
          end;

        if empty then
          begin
            params.DeleteNode(Result);
            Result := nil;
          end;
      end;
  end;

var
  srcGroup: PVirtualNode;
  empty: Boolean;
  params: TReportParameters;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  node := params.GetNode('/PARAMS/ICD9FILT');
  with ccrOtherDiagSelector180 do
  begin
    params.SetAttrVal(node, 'PROCMODE', ProcMode);
    params.SetAttrVal(node, 'FILTER', ICD9Filter);
    if rbIgnore180.Checked then
    begin
      params.DeleteChildren(node);
    end
    else begin

      empty := True;
      if ResultChanged or FullUpdate then
      begin
        params.DeleteChildren(node);
        srcGroup := ResultTree.GetFirstChild(nil);
        while Assigned(srcGroup) do
        begin
          if group(srcGroup, node) <> nil then
            empty := False;
          srcGroup := ResultTree.GetNextSibling(srcGroup);
        end;
        ResultChanged := False;
      end;
      if empty then
      begin
        aMsgLst.Add(RSC00225);
        aField := ccrOtherDiagSelector180;
      end;
    end;
  end;
end;

procedure TFrameReportParameters.pnlParams180Setup(
  const aReportCode: String);
begin
  with ccrOtherDiagSelector180 do
  begin
    ProcMode := False;
    Clear;
    CustomAdd := True;
    CustomRemove := True;
  end;
end;

procedure TFrameReportParameters.pnlParams180SetValues(
  const aReportCode: String; aList: TCustomReportParameters);

  function group(srcGroup: TDomNode): PVirtualNode;
  var
    srcItem: TDomNode;
    dstItem: PVirtualNode;
    params: TReportParameters;
    empty: Boolean;
    aName: String;
    dummy: String;
  begin
    params := TReportParameters(aList);
    with ccrOtherDiagSelector180.ResultTree do
      begin
        // Leave the "dummy := params.Text" line in even though it does nothing.
        // When it is removed, an access violation frequently occurs on the line
        // where GetAttrStr is used.
        dummy := params.Text;
        aName := params.GetAttrStr(srcGroup, 'ID');
        if aName <> '' then
          begin
            Result := FindGroup(aName);
            if not Assigned(Result) then
              Result := AddGroup(aName);
          end
        else
          Result := nil;
        if Assigned(Result) then
          begin
            DeleteChildren(Result);
            empty := True;
            srcItem := srcGroup.FirstChild;
            while Assigned(srcItem) do
              begin
                aName := params.GetNodeVal(srcItem);
                if aName <> '' then
                  begin
                    dstItem := AddItem(Result, aName, params.GetAttrStr(srcItem,'ID'));
                    empty := False;
                  end;
                srcItem := srcItem.NextSibling;
              end;
            if empty then
              begin
                DeleteGroup(Result);
                Result := nil;
              end;
          end;
      end;
  end;

var
  srcGroup: TDomNode;
  params: TReportParameters;
  empty: Boolean;
  node: TDomNode;
begin
  params := TReportParameters(aList);
  with ccrOtherDiagSelector180 do
  begin
    ResultTree.BeginUpdate;
    try
      node := params.FindNode('/PARAMS/ICD9FILT');
      if Assigned(node) and (params.GetAttrStr(node, 'FILTER') <> 'ALL') then
      begin
        empty := True;
        srcGroup := node.FirstChild;
        while Assigned(srcGroup) do
        begin
          if group(srcGroup) <> nil then
            empty := False;
          srcGroup := srcGroup.NextSibling;
        end;
        if not empty then
        begin
          if (params.GetAttrStr(node, 'FILTER') = 'INCLUDE') then
            rbInclude180.Checked := True
          else if (params.GetAttrStr(node, 'FILTER') = 'EXCLUDE') then
            rbExclude180.Checked := True;
        end
        else
          Clear;
      end
      else
        rbIgnore180.Checked := True; // This also clears the selector
    finally
      ResultTree.EndUpdate;
    end;
    ResultChanged := False;
  end;
end;

procedure TFrameReportParameters.rbIgnore180Click(Sender: TObject);
begin
  rbAllClick(Sender);
  cmbxOtherDiagSearch180.ItemIndex := 0;
end;

procedure TFrameReportParameters.cmbxOtherDiagSearch180Select(
  Sender: TObject);
begin
  if cmbxOtherDiagSearch180.ItemIndex <> dirNone then
    loadOtherDiagList;
end;

procedure TFrameReportParameters.loadOtherDiagList;
var
  i, n: Integer;
begin
  Screen.Cursor := crHourGlass;
  try
    Broker.CreateResults;
    //--- Clear the list of template names
    ccrOtherDiagSelector180.SourceList.Clear;
    //--- Load the list of template names
    if Broker.CallProc('ROR LIST PARAMETER INSTANCES',
       [sReportParamsTemplate, ICD9FilterType, '13::']) then
    begin
      ccrOtherDiagSelector180.SourceList.Items.BeginUpdate;
      try
        n := Broker.Results.Count - 1;
        for i := 1 to n do
          ccrOtherDiagSelector180.SourceList.AddItem(Piece(Broker.Results[i], U), nil);
      finally
        ccrOtherDiagSelector180.SourceList.Items.EndUpdate;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TFrameReportParameters.ccrOtherDiagSelector180Add(Sender: TObject);
var i: integer;
  rpcParam1: string;
  params: TReportParameters;
  rawData: TStringList;
begin
  params := TReportParameters.Create;
  rawData := TStringList.Create;
  try
    for i := 0 to ccrOtherDiagSelector180.SourceList.Items.Count-1 do
    begin
      if ccrOtherDiagSelector180.SourceList.Items[i].Selected then
      begin
        rpcParam1 := '13::' + ccrOtherDiagSelector180.SourceList.Items[i].Caption
          + U + sReportParamsTemplate;
        rawData.Clear;
        if Broker.CallProc(rpcGUIParameterGet, [rpcParam1, ICD9FilterType], nil, rawData) then
        begin
          rawData.Delete(0);
          rawData.Text := StringReplace(rawData.Text, 'ICD9LST', 'ICD9FILT', [rfReplaceAll]);
          params.Assign(rawData);
          pnlParams180.SetFieldValues('', params);
        end;
      end;
    end;
    ccrOtherDiagSelector180.SourceList.DeleteSelected;
  finally
    rawData.Free;
    params.Free;
  end;
end;

procedure TFrameReportParameters.ccrOtherDiagSelector180AddAll(Sender: TObject);
begin
  ccrOtherDiagSelector180.SourceList.SelectAll;
  ccrOtherDiagSelector180Add(Sender);
end;

procedure TFrameReportParameters.ccrOtherDiagSelector180Remove(Sender: TObject);
begin
  ccrOtherDiagSelector180.ResultTree.DeleteSelectedNodes;
end;

procedure TFrameReportParameters.ccrOtherDiagSelector180RemoveAll(
  Sender: TObject);
begin
  ccrOtherDiagSelector180.ResultTree.Clear;
  ccrOtherDiagSelector180.ResultTree.AddGroup('Diagnoses');
end;

procedure TFrameReportParameters.acOtherDiagGroupDeleteExecute(Sender: TObject);
begin
  deleteResultTreeGroup(ccrOtherDiagSelector180.ResultTree);
end;

procedure TFrameReportParameters.ccrOtherDiagSelector180ResultListKeyAction(
  Sender: TBaseVirtualTree; var CharCode: Word; var Shift: TShiftState;
  var DoDefault: Boolean);
begin
  if (Shift = []) and (CharCode = VK_DELETE) then
  begin
    deleteResultTreeGroup(ccrOtherDiagSelector180.ResultTree);
    DoDefault := False;
  end;
end;

///////////////////////////// Parameters Panel #201 \\\\\\\\\\\\\\\\\\\\\\\\\\\\

procedure TFrameReportParameters.pnlParams201Setup(const aReportCode: string);
var tmpLab: TLabel;
  iLength: integer;
begin
  if (aReportCode = '18') then
  begin
     pnlParams201.Caption := 'BMI Date Range';
     rbRangeMostRecent.Caption := 'Most recent BMI';
     rbRangeMax.Caption := 'BMI as of';
  end
  else if (aReportCode = '19') then
  begin
     pnlParams201.Caption := 'MELD Date Range';
     rbRangeMostRecent.Caption := 'Most recent MELD/MELD-Na score';
     rbRangeMax.Caption := 'MELD/MELD-Na as of';
  end
  else if (aReportCode = '20') then
  begin
     pnlParams201.Caption := 'Renal Function Date Range';
     rbRangeMostRecent.Caption := 'Most recent renal function';
     rbRangeMax.Caption := 'Renal function as of';
  end;
  //Calculate the size of the radio button text so we can position them properly
  tmpLab := TLabel.Create(pnlParams201);
  tmpLab.AutoSize := true;
  tmpLab.Font := rbRangeMostRecent.Font;
  tmpLab.Caption := rbRangeMostRecent.Caption;
  rbRangeMostRecent.Width := tmpLab.Width + 22;
  tmpLab.Font := rbRangeMax.Font;
  tmpLab.Caption := rbRangeMax.Caption;
  rbRangeMax.Width := tmpLab.Width + 22;
  rbRangeMax.Left := rbRangeMostRecent.Left + rbRangeMostRecent.Width + 40;
  dtpRangeMaxDate.Left := rbRangeMax.Left + rbRangeMax.Width + 2;
  tmpLab.Destroy;
end;

procedure TFrameReportParameters.pnlParams201GetValues(
  const aReportCode: string; aList: TCustomReportParameters; aMsgLst: TStrings;
  var aField: TWinControl);
var
  dateMax: Double;
begin
  with TReportParameters(aList) do
  begin
    SetAttrVal(NodeOptions, 'MOST_RECENT', rbRangeMostRecent.Checked);
    if rbRangeMax.Checked then
    begin
      dateMax := WindowsDateToFMDate(Trunc(dtpRangeMaxDate.Date));
      SetAttrVal(NodeOptions, 'MAX_DATE', FloatToStr(dateMax));
    end
    else begin
      SetAttrVal(NodeOptions, 'MOST_RECENT', rbRangeMostRecent.Checked);
      SetAttrVal(NodeOptions, 'MAX_DATE', '');
    end;
  end;
  if not (rbRangeMostRecent.Checked or rbRangeMax.Checked) then
  begin
    aMsgLst.Add(RSC00227);
    aField := rbRangeMostRecent;
  end;
end;

procedure TFrameReportParameters.pnlParams201SetValues(
  const aReportCode: string; aList: TCustomReportParameters);
var
  maxDate: integer;
begin
  with TReportParameters(aList) do
  begin
    rbRangeMostRecent.Checked := GetAttrBool(NodeOptions, 'MOST_RECENT');
    if not rbRangeMostRecent.Checked then
    begin
      rbRangeMax.Checked := true;
      try
        maxDate := GetAttrInt(NodeOptions, 'MAX_DATE');
        if maxDate = 0 then
          dtpRangeMaxDate.Date := Date
        else
          dtpRangeMaxDate.Date := FMDateTimeToWindowsDateTime(maxDate);
      except
        dtpRangeMaxDate.Date := Date;
      end;

    end;
  end;
end;

procedure TFrameReportParameters.rbToggleDateEntry(Sender: TObject);
begin
  dtpRangeMaxDate.Enabled := (Sender = rbRangeMax);
  dtpRangeMaxDate.Color := CtrlColor(dtpRangeMaxDate.Enabled);
end;

end.

