unit uROR_HEPCPatientData;
{
================================================================================
*
*       Package:        ROR - Clinical Case Registries
*       Date Created:   $Revision: 9 $  $Modtime: 11/10/05 3:00p $
*       Site:           Hines OIFO
*       Developers:     Sergey Gavrilov
*       Description:    HepC Patient Object
*
*	Notes:
*
================================================================================
*	$Archive: /CCR v1.0/Current/uROR_HEPCPatientData.pas $
*
* $History: uROR_HEPCPatientData.pas $
 * 
 * *****************  Version 9  *****************
 * User: Vhaishgavris Date: 11/10/05   Time: 3:28p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 8  *****************
 * User: Vhaishgavris Date: 8/18/05    Time: 4:56p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 7  *****************
 * User: Vhaishgavris Date: 2/16/05    Time: 3:55p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 6  *****************
 * User: Vhaishgavris Date: 10/14/04   Time: 3:50p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 5  *****************
 * User: Vhaishgavris Date: 4/16/04    Time: 4:14p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 4  *****************
 * User: Vhaishgavris Date: 4/15/04    Time: 3:55p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 3  *****************
 * User: Vhaishgavris Date: 4/12/04    Time: 3:55p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 2  *****************
 * User: Vhaishgavris Date: 4/09/04    Time: 3:55p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 3  *****************
 * User: Vhaishgavris Date: 4/06/04    Time: 4:06p
 * Updated in $/CCR v1.0/Current
 * 
 * *****************  Version 2  *****************
 * User: Vhaishgavris Date: 4/02/04    Time: 3:29p
 * Updated in $/CCR v1.0/Current
 *
 * *****************  Version 1  *****************
 * User: Vhaishgavris Date: 4/02/04    Time: 8:41a
 * Created in $/CCR v1.0/Current
 *
*
================================================================================
}

interface

uses
  Classes, uROR_Common, uROR_PatientData, uROR_Errors;

type

  THEPCPatientData = class(TPatientData)
  public
    constructor Create(const aRegIEN: String);

    function  Save(var ErrSeg: String; var ErrPiece: Integer): TReturnCode; override;

  end;

implementation

uses
  SysUtils, uROR_CommonUtils, uROR_Utilities;

//////////////////////////////// THEPCPatientData \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

constructor THEPCPatientData.Create(const aRegIEN: String);
begin
  inherited;
  LoadRPCName   := 'RORHEPC PATIENT LOAD';
  SaveRPCName   := 'RORHEPC PATIENT SAVE';
end;

function THEPCPatientData.Save(var ErrSeg: String; var ErrPiece: Integer): TReturnCode;
begin
  if not ReadOnly and (Status = '4') then
    Modified := True;
  Result := inherited Save(ErrSeg, ErrPiece);
end;

end.
