unit uROR_UDPatientData;
{
================================================================================
*
*       Package:        ROR - Clinical Case Registries
*       Date Created:   $Revision: 2 $  $Modtime: 1/25/07 9:20a $
*       Site:           Hines OIFO
*       Developers:     Sergey Gavrilov
*       Description:    User Defined Patient Object
*
*	Notes:
*
================================================================================
*	$Archive: /CCR v1.5/Current/uROR_UDPatientData.pas $
*
* $History: uROR_UDPatientData.pas $
 * 
 * *****************  Version 2  *****************
 * User: Vhaishgavris Date: 1/25/07    Time: 9:57a
 * Updated in $/CCR v1.5/Current
 * 
 * *****************  Version 1  *****************
 * User: Vhaishgavris Date: 4/02/04    Time: 8:41a
 * Created in $/CCR v1.0/Current
 *
*
================================================================================
}

interface

uses
  Classes, uROR_Common, uROR_PatientData, uROR_Errors;

type

  TUDPatientData = class(TPatientData)
  public
    constructor Create(const aRegIEN: String);

    function  Save(var ErrSeg: String; var ErrPiece: Integer): TReturnCode; override;

  end;

implementation

uses
  SysUtils, uROR_CommonUtils, uROR_Utilities;

///////////////////////////////// TUDPatientData \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

constructor TUDPatientData.Create(const aRegIEN: String);
begin
  inherited;
  LoadRPCName   := 'RORHEPC PATIENT LOAD';
  SaveRPCName   := 'RORHEPC PATIENT SAVE';
end;

function TUDPatientData.Save(var ErrSeg: String; var ErrPiece: Integer): TReturnCode;
begin
  if not ReadOnly and (Status = '4') then
    Modified := True;
  Result := inherited Save(ErrSeg, ErrPiece);
end;

end.
